''This macro is a online translations macro program for strings
''in Passolo translation list.
''It has the following features:
''- Use the online translation engine automatically translate strings
''  in the Passolo translation list
''- Integrated some of the well-known online translation engines, and
''  you can customize other online translation engines
''- You can choose the string type, skiping some of string, and processing
''  the strings before and after translation
''- Integrated shortcuts, terminators, Accelerator check macro, and you can
''  check and correct errors in translations after the strings has be translated
''Idea and implemented by wanfu 2010.05.12 (modified on 2011.05.20)

Public CodeList() As String,UILangList() As String,LangFile As String

Public SpaceTrn As String,acckeyTrn As String,ExpStringTrn As String,EndStringTrn As String
Public acckeySrc As String,EndStringSrc As String,ShortcutSrc As String,ShortcutTrn As String
Public PreStringTrn As String,EndSpaceSrc As String,EndSpaceTrn As String

Public DefaultCheckList() As String,CheckDataList() As String,AppRepStr As String,PreRepStr As String
Public AllCont As Long,AccKey As Long,EndChar As Long,Acceler As Long

Public DefaultEngineList() As String,EngineDataList() As String,tSelected() As String,WaitTimes As Long

Private Const Version = "2011.05.20"
Private Const ToUpdateEngineVersion = "2011.04.16"
Private Const ToUpdateCheckVersion = "2011.05.20"
Private Const EngineRegKey = "HKCU\Software\VB and VBA Program Settings\WebTranslate\"
Private Const EngineFilePath = MacroDir & "\Data\PSLWebTrans.dat"
Private Const CheckRegKey = "HKCU\Software\VB and VBA Program Settings\AccessKey\"
Private Const CheckFilePath = MacroDir & "\Data\PSLCheckAccessKeys.dat"
Private Const JoinStr = vbBack
Private Const SubJoinStr = Chr$(1)
Private Const LngJoinStr = "|"
Private Const NullValue = "Null"
Private Const DefaultObject = "Microsoft.XMLHTTP"


'Ĭ
Function EngineSettings(DataName As String) As String
	Dim ObjectName As String,Template As String,AppId As String,openUrl As String,openMethod As String
	Dim openAsync As String,openUser As String,openPassword As String,sendBody As String
	Dim setRequestHeader As String,responseType As String,TranBeforeStr As String,TranAfterStr As String

	If DataName = DefaultEngineList(0) Then
		ObjectName = DefaultObject
		AppId = "fefed727-bbc1-4421-828d-fc828b24d59b"
		openUrl = "http://api.microsofttranslator.com/V2/Http.svc/Translate?"
		Template = "{Url}&appId={appId}&text={text}&from={from}&to={to}"
		openMethod = "GET"
		openAsync = "False"
		openUser = ""
		openPassword = ""
		sendBody = ""
		setRequestHeader = "Content-Type,application/xml; charset=utf-8"
		responseType = "responseText"
		TranBeforeStr = "Serialization/"">"
		TranAfterStr = "</string>"
		Enable = "1"
	ElseIf DataName = DefaultEngineList(1) Then
		ObjectName = DefaultObject
		AppId = ""
		openUrl = "http://translate.google.com/translate_t?"
		Template = "{Url}&text={text}&langpair={from}|{to}"
		openMethod = "POST"
		openAsync = "False"
		openUser = ""
		openPassword = ""
		sendBody = ""
		setRequestHeader = "Content-Type,text/html; charset=utf-8"
		responseType = "responseText"
		TranBeforeStr = "onmouseout=""this.style.backgroundColor='#fff'"">"
		TranAfterStr = "</span>"
		Enable = "1"
	ElseIf DataName = DefaultEngineList(2) Then
		ObjectName = DefaultObject
		AppId = ""
		openUrl = "http://fanyi.yahoo.com.cn/translate_txt?"
		Template = "{Url}&ei=UTF-8&fr=&lp={from}_{to}&trtext={Text}"
		openMethod = "POST"
		openAsync = "False"
		openUser = ""
		openPassword = ""
		sendBody = ""
		setRequestHeader = "Content-Type,text/html; charset=utf-8"
		responseType = "responseText"
		TranBeforeStr = "<div id=""pd"" class=""pd"">"
		TranAfterStr = "</div>"
		Enable = "0"
	End If
	EngineSettings = ObjectName & SubJoinStr & AppId & SubJoinStr & openUrl & SubJoinStr & _
					Template & SubJoinStr & openMethod & SubJoinStr & openAsync & SubJoinStr & _
					openUser & SubJoinStr & openPassword & SubJoinStr & sendBody & SubJoinStr & _
					setRequestHeader & SubJoinStr & responseType & SubJoinStr & _
					TranBeforeStr & SubJoinStr & TranAfterStr & SubJoinStr & Enable
End Function


'ִĬ
Function CheckSettings(DataName As String) As String
	Dim i As Long,j As Long,Max As Long,CheckName As String
	Dim TempList() As String,readByte() As Byte,DefaultCheckDataList() As String

	ConfigFile = MacroDir & "\Data\PSLCheckAccessKeys.ini"
	If Dir(ConfigFile) = "" Then
		On Error Resume Next
		FN = FreeFile
		Open ConfigFile For Input As #FN
		Close #FN
		PSL.Output(Err.Description & vbCrLf & ConfigFile)
		On Error GoTo 0
		Exit Function
	Else
		i = FileLen(ConfigFile)
		ReDim readByte(i) As Byte
		On Error Resume Next
		FN = FreeFile
		Open ConfigFile For Binary As #FN
		Get #FN,,readByte
		Close #FN
		On Error GoTo 0
		DefaultCheckDataList = Split(readByte,vbCrLf)
		Erase readByte
		If Join(DefaultCheckDataList,"") = "" Then
			PSL.Output(Err.Description & vbCrLf & ConfigFile)
			Exit Function
		End If
	End If

	If DataName = DefaultCheckList(0) Then CheckName = "en2zh"
	If DataName = DefaultCheckList(1) Then CheckName = "zh2en"
	ReDim TempList(0)
	j = 0
	Max = UBound(DefaultCheckDataList)
	For i = 0 To Max
		L$ = DefaultCheckDataList(i)
		If Left(Trim(L$),1) = "[" And Right(Trim(L$),1) = "]" Then
			Header$ = Mid(Trim(L$),2,Len(Trim(L$))-2)
		End If
		If L$ <> "" And Header$ <> "" Then
			setPreStr$ = ""
			setAppStr$ = ""
			If InStr(L$,"=") Then
				setPreStr$ = Trim(Left(L$,InStr(L$,"=")-1))
				setAppStr$ = Trim(Mid(L$,InStr(L$,"=")+1))
			End If
			If setPreStr$ <> "" And Header$ = "Option" Then
				If CheckName = "" Then
					If setAppStr$ = DataName Then CheckName = setPreStr$
				End If
			End If
			If setPreStr$ <> "" And Header$ <> "Option" Then
				If Header$ = CheckName Then
					ReDim Preserve TempList(j)
					TempList(j) = setAppStr$
					j = j + 1
				End If
			End If
		End If
		If j > 0 And (Trim(L$) = "" Or i = Max) Then
			CheckSettings = Join(TempList,SubJoinStr)
			Exit For
		End If
	Next i

	If j = 0 Then
		If Join(UILangList,"") = "" Then
			Msg = "The following file is missing [" & CheckName & "] section."
			PSL.Output(Msg & vbCrLf & ConfigFile)
		Else
			On Error Resume Next
			Err.Raise(1,"NotSection",ConfigFile & JoinStr & CheckName)
			Call sysErrorMassage(Err)
			On Error GoTo 0
		End If
	End If
End Function


' 
Public Sub PSL_OnAutoTranslate(Translations As PslTranslations,ByVal MinMatch As Long,ByVal MaxCount As Long)
	Dim TransString As PslTransString
	Dim i As Long,j As Long,srcString As String,trnString As String,TranLang As String
	Dim LangPairList() As String,xmlHttp As Object,objStream As Object
	Dim EngineID As Long,LangPair As String,k As Long,Temp As String,Stemp As Boolean
	Dim srcLng As String,trnLng As String,srcLngFind As String,trnLngFind As String
	Dim strKeyPath As String,WshShell As Object,MsgList() As String,readByte() As Byte

	'ϵͳ
	On Error Resume Next
	Set WshShell = CreateObject("WScript.Shell")
	If WshShell Is Nothing Then
		PSL.Output(Err.Description & " - " & "WScript.Shell")
		Exit Sub
	End If
	strKeyPath = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\Default"
	OSLanguage = WshShell.RegRead(strKeyPath)
	If OSLanguage = "" Then
		strKeyPath = "HKLM\SYSTEM\CurrentControlSet\Control\Nls\Language\InstallLanguage"
		OSLanguage = WshShell.RegRead(strKeyPath)
	End If
	Set WshShell = Nothing

	' Microsoft.XMLHTTP Ƿ
	Set xmlHttp = CreateObject(DefaultObject)
	If xmlHttp Is Nothing Then Set xmlHttp = CreateObject("Msxml2.XMLHTTP")
	If xmlHttp Is Nothing Then
		PSL.Output(Err.Description & " - " & DefaultObject)
		Exit Sub
	End If

	' Adodb.Stream Ƿ
	Set objStream = CreateObject("Adodb.Stream")
	If objStream Is Nothing Then
		PSL.Output(Err.Description & " - " & "Adodb.Stream")
		Exit Sub
	End If
	Set objStream = Nothing

	'ʼ
	ReDim DefaultEngineList(2),EngineDataList(0)
	ReDim DefaultCheckList(1),CheckDataList(0)

	'ȡ
	DefaultEngineList(0) = "Microsoft"
	DefaultEngineList(1) = "Google"
	DefaultEngineList(2) = "Yahoo"
	If EngineGet("",EngineDataList,"") = False Then
		For i = LBound(DefaultEngineList) To UBound(DefaultEngineList)
			EngineName = DefaultEngineList(i)
			LangPairs = Join(LangCodeList(EngineName,0,107),SubJoinStr)
			Temp = EngineName & JoinStr & EngineSettings(EngineName) & JoinStr & LangPairs
			CreateArray(EngineName,Temp,EngineDataList)
		Next i
	Else
		For i = LBound(DefaultEngineList) To UBound(DefaultEngineList)
			EngineName = DefaultEngineList(i)
			If InStr(Join(EngineDataList,JoinStr),EngineName) = 0 Then
				LangPairs = Join(LangCodeList(EngineName,0,107),SubJoinStr)
				Temp = EngineName & JoinStr & EngineSettings(EngineName) & JoinStr & LangPairs
				CreateArray(EngineName,Temp,EngineDataList)
			End If
		Next i
	End If

	'ȡִ
	If tSelected(26) = "0" Or tSelected(26) = "" Then
		LangFile = MacroDir & "\Data\PslWebTrans_" & OSLanguage & ".lng"
	Else
		LangFile = MacroDir & "\Data\PslWebTrans_" & tSelected(26) & ".lng"
	End If
	If Dir(LangFile) = "" Then
		Temp = MacroDir & "\Data\PslWebTrans_" & OSLanguage & ".lng"
		If Temp <> LangFile Then LangFile = Temp
		If Dir(LangFile) = "" Then
			For i = 0 To 1
				If i = 0 Then Temp = MacroDir & "\Data\PslWebTrans_0804.lng"
				If i = 1 Then Temp = MacroDir & "\Data\PslWebTrans_0404.lng"
				If Dir(Temp) <> "" Then
					LangFile = Temp
					Exit For
				End If
			Next i
		End If
		If Dir(LangFile) = "" Then
			FN = FreeFile
			Open LangFile For Input As #FN
			Close #FN
			PSL.Output(Err.Description & vbCrLf & LangFile)
			Exit Sub
		End If
	End If
	i = FileLen(LangFile)
	ReDim readByte(i) As Byte
	FN = FreeFile
	Open LangFile For Binary As #FN
	Get #FN,,readByte
	Close #FN
	UILangList = Split(readByte,vbCrLf)
	Erase readByte
	If Join(UILangList,"") = "" Then
		PSL.Output(Err.Description & vbCrLf & LangFile)
		Exit Sub
	End If
	On Error GoTo SysErrorMsg
	ItemList$ = "Main"
	If getMsgList(UILangList,MsgList,ItemList$,0) = False Then
		Err.Raise(1,"NotSection",LangFile & JoinStr & ItemList$)
	End If

	' PSL 汾
	If PSL.Version < 600 Then
		PSL.Output(MsgList(41) & ":" & MsgList(43))
		Exit Sub
	End If

	'ȡַб
	CodeList = CodePageList(0,49)

	'ת
	If Join(tSelected,"") <> "" Then
		'EngineName = tSelected(0)
		CheckName = tSelected(1)
		'mAllType = StrToLong(tSelected(2))
		'mMenu = StrToLong(tSelected(3))
		'mDialog = StrToLong(tSelected(4))
		'mString = StrToLong(tSelected(5))
		'mAccTable = StrToLong(tSelected(6))
		'mVer = StrToLong(tSelected(7))
		'mOther = StrToLong(tSelected(8))
		mSelOnly = StrToLong(tSelected(9))
		'mForReview = StrToLong(tSelected(10))
		'mValidated = StrToLong(tSelected(11))
		'mNotTran = StrToLong(tSelected(12))
		mNumAndSymbol = StrToLong(tSelected(13))
		mAllUCase = StrToLong(tSelected(14))
		mAllLCase = StrToLong(tSelected(15))
		mAutoSele = StrToLong(tSelected(16))
		mAccKey = StrToLong(tSelected(17))
		mAccelerator = StrToLong(tSelected(18))
		mPreStrRep = StrToLong(tSelected(19))
		mSplitTrn = StrToLong(tSelected(20))
		mCheckTrn = StrToLong(tSelected(21))
		mAppStrRep = StrToLong(tSelected(22))
		'KeepSet = StrToLong(tSelected(23))
		'mShowMsg = StrToLong(tSelected(24))
		mTranComm = StrToLong(tSelected(25))
	End If

	'ȡִ
	'If mMenu = 1 Then StrTypes = "|Menu|"
	'If mDialog = 1 Then StrTypes = StrTypes & "|Dialog|"
	'If mString = 1 Then StrTypes = StrTypes & "|StringTable|"
	'If mAccTable = 1 Then StrTypes = StrTypes & "|AcceleratorTable|"
	'If mVer = 1 Then StrTypes = StrTypes & "|Version|"

	'ȡPSLԴԴ
	srcLng = PSL.GetLangCode(Translations.SourceLangID,pslCode639_1)
	If srcLng = "" Then srcLng = PSL.GetLangCode(Translations.SourceLangID,pslCodeLangRgn)
	If srcLng = "zh" Then
		srcLng = PSL.GetLangCode(Translations.SourceLangID,pslCodeLangRgn)
		If srcLng = "zh-CHS" Or srcLng = "zh-SG" Then srcLng = "zh-CN"
		If srcLng = "zh-CHT" Or srcLng = "zh-HK" Or srcLng = "zh-MO" Then srcLng = "zh-TW"
	End If

	'ȡPSLĿԴ
	trnLng = PSL.GetLangCode(Translations.TargetLangID,pslCode639_1)
	If trnLng = "" Then trnLng = PSL.GetLangCode(Translations.TargetLangID,pslCodeLangRgn)
	If trnLng = "zh" Or trnLng = "ja" Or trnLng = "ko" Then TranLang = "Asia"
	If trnLng = "zh" Then
		trnLng = PSL.GetLangCode(Translations.TargetLangID,pslCodeLangRgn)
		If trnLng = "zh-CHS" Or trnLng = "zh-SG" Then trnLng = "zh-CN"
		If trnLng = "zh-CHT" Or trnLng = "zh-HK" Or trnLng = "zh-MO" Then trnLng = "zh-TW"
	End If

	'ȡִ
	DefaultCheckList(0) = MsgList(70)
	DefaultCheckList(1) = MsgList(71)
	If mAutoSele = 1 Then
		Stemp = CheckGet(trnLng,CheckDataList,"",1)
		If Stemp = False Then Stemp = CheckGet(CheckName,CheckDataList,"",0)
	Else
		Stemp = CheckGet(CheckName,CheckDataList,"",0)
	End If
	If Stemp = False Then
		If TranLang = "Asia" Then CheckName = DefaultCheckList(0)
		If TranLang <> "Asia" Then CheckName = DefaultCheckList(1)
		If CheckGet(CheckName,CheckDataList,"",0) = False Then
			Temp = CheckSettings(CheckName)
			If Temp <> "" Then
				CheckDataList(0) = CheckName & JoinStr & Temp
			Else
				CheckName = MsgList(88)
				Temp = SubJoinStr & SubJoinStr & SubJoinStr & SubJoinStr & _
					 	SubJoinStr & SubJoinStr & SubJoinStr & SubJoinStr & _
				 		SubJoinStr & SubJoinStr & SubJoinStr & SubJoinStr
				CheckDataList(0) = CheckName & JoinStr & Temp
				mAccKey = 0
				mAccelerator = 0
				mPreStrRep = 0
				mCheckTrn = 0
				mAppStrRep = 0
			End If
		End If
	End If
	AllCont = 1
	AccKey = 0
	EndChar = 0
	Acceler = 0

	'ִʼȡбԴͷִ
	OldSrcString = Translations.SourceString
	srcString = OldSrcString

	'ִʹ
	'If mAllType = 0 And mSelOnly = 0 Then
	'	If InStr("Menu|Dialog|StringTable|AcceleratorTable|Version",TransString.ResType) Then
	'		If InStr(StrTypes,TransString.ResType) = 0 Then GoTo Skip
	'	Else
	'		If mOther = 0 Then GoTo Skip
	'	End If
	'End If

	'ΪջȫΪոִ
	If Trim(OldSrcString) = "" Then GoTo Skip
	'ȫΪֺͷŵִ
	If mNumAndSymbol = 1 Then
		If LCase(OldSrcString) = UCase(OldSrcString) Then
			If CheckStr(OldSrcString,"0-64,91-96,123-191") = True Then GoTo Skip
		End If
	End If
	'ȫΪдӢĵִ
	If mAllUCase = 1 Then
		If UCase(OldSrcString) = OldSrcString Then
			If CheckStr(OldSrcString,"65-90") = True Then GoTo Skip
		End If
	End If
	'ȫΪСдӢĵִ
	If mAllLCase = 1 Then
		If LCase(OldSrcString) = OldSrcString Then
			If CheckStr(OldSrcString,"97-122") = True Then GoTo Skip
		End If
	End If

	'ʼԤִ
	If mAccKey = 0 Then srcString = Replace(srcString,"&","")
	If mPreStrRep = 1 Then srcString = ReplaceStr(0,srcString,1)
	If mSplitTrn = 0 Then
		If mAccKey = 1 Then srcString = AccessKeyHanding(0,srcString)
		If mAccelerator = 1 Then srcString = AcceleratorHanding(0,srcString)
	End If

	'ֱõķ淭ִк
	k = 0
	MaxCount = MaxCount + UBound(EngineDataList) + 1
	For j = 0 To UBound(EngineDataList)
		'ҷжӦԴ
		TempArray = Split(EngineDataList(j),JoinStr)
		SetsArray = Split(TempArray(1),SubJoinStr)
		LangArray = Split(TempArray(2),SubJoinStr)
		EngineName = TempArray(0)
		EngineID = j
		srcLngFind = ""
		trnLngFind = ""
		LangPair = ""
		trnString = ""
		If SetsArray(13) <> "1" Then GoTo NextNum
		For i = 0 To UBound(LangArray)
			LangPairList = Split(LangArray(i),LngJoinStr)
			If LCase(srcLng) = LCase(LangPairList(1)) Then
				srcLngFind = LangPairList(2)
			End If
			If LCase(trnLng) = LCase(LangPairList(1)) Then
				trnLngFind = LangPairList(2)
			End If
			If srcLngFind <> "" And trnLngFind <> "" Then Exit For
		Next i
		If trnLngFind = "" Or trnLngFind = NullValue Then GoTo NextNum
		LangPair = srcLngFind & LngJoinStr & trnLngFind

		'ͷŲʹõĶ̬ʹõڴ
		Erase TempArray,SetsArray,LangArray,LangPairList

		'ȡԷ
		'Temp = getTranslate(EngineID,xmlHttp,"Test",LangPair,3)
		' Internet 
		'If Temp = "NotConnected" Then Exit Sub
		'ַǷΪ
		'If Temp = "NullUrl" Then GoTo NextNum
		'Ƿʱ
		'If Temp = "Timeout" Then GoTo NextNum
		'ǷΪ
		'If Trim(Temp) = "" Then GoTo NextNum

		'ʼִ
		If mSplitTrn = 0 Then
			trnString = getTranslate(EngineID,xmlHttp,srcString,LangPair,0)
		Else
			Temp = EngineID & JoinStr & 0 & JoinStr & mAccKey & JoinStr & mAccelerator & JoinStr & k
			trnString = SplitTran(xmlHttp,srcString,LangPair,Temp,0)
		End If

		'ʼִ滻ԭз
		If Trim(trnString) <> "" And trnString <> OldSrcString Then
			If mCheckTrn = 1 Then
				trnString = CheckHanding(0,OldSrcString,trnString)
			End If
			If mAppStrRep = 1 Then trnString = ReplaceStr(0,trnString,0)
			'If mPreStrRep = 1 Then trnString = ReplaceStr(0,trnString,2)

			Translations.Add(trnString,OldSrcString,100,EngineName & " " & MsgList(4))
		End If
		NextNum:
		If Translations.Count = MaxCount Then Exit For
		k = 1
	Next j
	Skip:
	Set xmlHttp = Nothing
	Exit Sub

	'ʾϢ
	SysErrorMsg:
	Call sysErrorMassage(Err)
End Sub


'ȡ߷
Function getTranslate(ID As Long,xmlHttp As Object,srcStr As String,LngPair As String,fType As Long) As String
	Dim UrlData As String,trnStr As String,LangFrom As String,LangTo As String,Temp As String
	Dim pos As Long,Code As String,srcStrBak As String,Body As Variant,xmlObj As Object

	If Trim(srcStr) = "" Or LngPair = "" Then Exit Function
	TempArray = Split(EngineDataList(ID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	AppId = SetsArray(1)
	Url = SetsArray(2)
	UrlTemplate = SetsArray(3)
	Method = SetsArray(4)
	Async = SetsArray(5)
	User = SetsArray(6)
	Password = SetsArray(7)
	Body = SetsArray(8)
	RequestHeader = SetsArray(9)
	responseType = SetsArray(10)
	TranBeforeStr = SetsArray(11)
	TranAfterStr = SetsArray(12)

	If Url = "" Then
		If fType = 3 Then getTranslate = "NullUrl"
		Exit Function
	End If

	If LngPair <> "" Then
		LangFrom = Left(LngPair,InStr(LngPair,LngJoinStr)-1)
		LangTo = Mid(LngPair,InStr(LngPair,LngJoinStr)+1)
	End If

	srcStrBak = srcStr
	If InStr(LCase(RequestHeader),"charset") Then
		Temp = Mid(RequestHeader,InStr(LCase(RequestHeader),"charset"))
		If InStr(Temp,"=") Then Code = ExtractStr(Temp,"=",";",1)
	Else
		On Error GoTo ErrorHandler
		xmlHttp.Open Method,Url,Async,User,Password
		xmlHttp.send()
		Temp = xmlHttp.getResponseHeader("Content-Type")
		If InStr(LCase(Temp),"charset") Then
			Temp = Mid(Temp,InStr(LCase(Temp),"charset"))
			If InStr(Temp,"=") Then Code = ExtractStr(Temp,"=",";",1)
		Else
			Temp = xmlHttp.responseText
			If InStr(LCase(Temp),"charset") Then
				Temp = Mid(Temp,InStr(LCase(Temp),"charset"))
				If InStr(Temp,"=") Then Code = ExtractStr(Temp,"=",">",1)
			ElseIf InStr(LCase(Temp),"lang") Then
				Temp = Mid(Temp,InStr(LCase(Temp),"lang"))
				If InStr(Temp,"=") Then Code = ExtractStr(Temp,"=",">",1)
			End If
		End If
		xmlHttp.Abort
		On Error GoTo 0
	End If
	If Code <> "" Then Code = RemoveBackslash(Code,"""","""",1)
	If LCase(Code) = "utf-8" Or LCase(Code) = "utf8" Then
		srcStrBak = Utf8Encode(srcStrBak)
	Else
		srcStrBak = ANSIEncode(srcStrBak)
	End If

	If UrlTemplate <> "" Then
		UrlData = LCase(UrlTemplate)
		If InStr(UrlData,"{url}") = 0 Then UrlData = Url & UrlData
		If InStr(UrlData,"{url}") Then UrlData = Replace(UrlData,"{url}",Url)
		If InStr(UrlData,"{appid}") Then UrlData = Replace(UrlData,"{appid}",AppId)
		If InStr(UrlData,"{text}") Then UrlData = Replace(UrlData,"{text}",srcStrBak)
		If InStr(UrlData,"{from}") Then UrlData = Replace(UrlData,"{from}",LangFrom)
		If InStr(UrlData,"{to}") Then UrlData = Replace(UrlData,"{to}",LangTo)
	End If

	If Body <> "" Then
		BodyData = LCase(Body)
		If InStr(BodyData,"{url}") Then BodyData = Replace(BodyData,"{url}",Url)
		If InStr(BodyData,"{appid}") Then BodyData = Replace(BodyData,"{appid}",AppId)
		If InStr(BodyData,"{text}") Then BodyData = Replace(BodyData,"{text}",srcStrBak)
		If InStr(BodyData,"{from}") Then BodyData = Replace(BodyData,"{from}",LangFrom)
		If InStr(BodyData,"{to}") Then BodyData = Replace(BodyData,"{to}",LangTo)
	End If

	If RequestHeader <> "" Then
		RequestData = LCase(RequestHeader)
		If InStr(RequestData,"{url}") Then RequestData = Replace(RequestData,"{url}",Url)
		If InStr(RequestData,"{appid}") Then RequestData = Replace(RequestData,"{appid}",AppId)
		If InStr(RequestData,"{text}") Then RequestData = Replace(RequestData,"{text}",srcStrBak)
		If InStr(RequestData,"{from}") Then RequestData = Replace(RequestData,"{from}",LangFrom)
		If InStr(RequestData,"{to}") Then RequestData = Replace(RequestData,"{to}",LangTo)
	End If

	On Error GoTo ErrorHandler
    xmlHttp.Open Method,UrlData,Async,User,Password
    If RequestHeader <> "" Then
		FindStrArr = Split(RequestData,vbCrLf)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
    		FindStr = FindStrArr(i)
    		pos = InStr(FindStr,",")
    		If pos = 0 Then pos = InStr(FindStr,":")
			If pos <> 0 Then
				bstrHeader = Trim(Left(FindStr,pos-1))
				bstrValue = Trim(Mid(FindStr,pos+1))
				If LCase(bstrHeader) = LCase("Content-Length") Then
					xmlHttp.setRequestHeader bstrHeader,LenB(bstrValue)
				Else
					xmlHttp.setRequestHeader bstrHeader,bstrValue
				End If
			End If
		Next i
	End If
   	xmlHttp.send(BodyData)
	If xmlHttp.readyState < 4 Then
		xmlHttp.TimeOut = WaitTimes
		Wait WaitTimes
		If xmlHttp.readyState < 4 Then getTranslate = "Timeout"
	End If
	If xmlHttp.readyState = 4 Then
		If fType <> 2 Then
			If responseType = "responseText" Then
				trnStr = xmlHttp.responseText
			ElseIf responseType = "responseXML" Then
				If fType = 0 Or fType = 3 Then
					Set xmlObj = xmlHttp.responseXML
					If Not xmlObj Is Nothing Then
						trnStr = ReadXML(xmlObj,TranBeforeStr,TranAfterStr)
					End If
					Set xmlObj = Nothing
				End If
				If fType = 1 Then trnStr = xmlHttp.responseText
			ElseIf responseType = "responseStream" Then
				If fType = 0 Or fType = 3 Then
					Body = xmlHttp.responseStream
					If LenB(Body) > 0 Then trnStr = BytesToBstr(Body,Code)
				End If
				If fType = 1 Then trnStr = xmlHttp.responseText
			ElseIf responseType = "responseBody" Then
				If fType = 0 Or fType = 3 Then
					Body = xmlHttp.responseBody
					If LenB(Body) > 0 Then trnStr = BytesToBstr(Body,Code)
				End If
				If fType = 1 Then trnStr = xmlHttp.responseText
			End If
		Else
			trnStr = xmlHttp.getAllResponseHeaders
		End If
		xmlHttp.Abort
		On Error GoTo 0

		'If responseType = "responseText" Then
		'	If LCase(Code) <> "utf-8" And LCase(Code) <> "utf8" Then
				'trnStr = ConvStr(trnStr,Code,"utf16")
				'codepage = trn.Language.Option(pslOptionActualCodepage)
				 'trnStr = PSL.ConvertASCII2Unicode(trnStr,codepage)
		'	End If
		'End If

		If fType = 0 Or fType = 3 Then
			If responseType = "responseXML" Then
				getTranslate = trnStr
			ElseIf trnStr <> "" Then
				getTranslate = ExtractStr(trnStr,TranBeforeStr,TranAfterStr,0)
			End If
    	Else
    		getTranslate = trnStr
		End If
		Exit Function
	End If
	On Error GoTo 0

    ErrorHandler:
    If Err.Number <> 0 Then
    	If fType = 3 Then getTranslate = "NotConnected"
	End If
End Function


'Utf-8 
Function Utf8Encode(textStr As String) As String
	Dim Wch As String,Uch As String,Szret As String,i As Long,Nasc As Long
	Utf8Encode = textStr
	If Trim(textStr) = "" Then Exit Function
	For i = 1 To Len(textStr)
		Wch = Mid(textStr,i,1)
		Nasc = AscW(Wch)
		If Nasc < 0 Then Nasc = Nasc + 65536
		If (Nasc And &hff80) = 0 Then
			Szret = Szret & Wch
		Else
			If (Nasc And &hf000) = 0 Then
				Uch = "%" & Hex(((Nasc \2 ^ 6)) Or &hc0) & Hex(Nasc And &h3f Or &h80)
				Szret = Szret & Uch
			Else
				Uch = "%" & Hex((Nasc \ 2 ^ 12) Or &he0) & "%" & _
							Hex((Nasc \ 2 ^ 6) And &h3f Or &h80) & "%" & _
							Hex(Nasc And &h3f Or &h80)
				Szret = Szret & Uch
			End If
		End If
	Next i
	Utf8Encode = Szret
End Function


'ANSI 
Public Function ANSIEncode(textStr As String) As String
    Dim i As Long,startIndex As Long,endIndex As Long,x() As Byte
    ANSIEncode = textStr
    If Trim(textStr) = "" Then Exit Function
    x = StrConv(textStr,vbFromUnicode)
    startIndex = LBound(x)
    endIndex = UBound(x)
    For i = startIndex To endIndex
        ANSIEncode = ANSIEncode & "%" & Hex(x(i))
    Next i
End Function


'תַıʽ
Function ConvStr(textStr As String,inCode As String,outCode As String) As String
	Dim objStream As Object
    ConvStr = textStr
    If Trim(textStr) = "" Or inCode = "" Or outCode = "" Then Exit Function
    On Error Resume Next
    Set objStream = CreateObject("Adodb.Stream")
    If objStream Is Nothing Then
    	Err.Source = "Adodb.Stream"
    	Call sysErrorMassage(Err)
    	Exit Function
    End If
    On Error GoTo 0
    With objStream
    	.Type = 2
    	.Mode = 3
    	.CharSet = inCode
    	.Open
    	.WriteText textStr
    	.Position = 0
    	.CharSet = outCode
    	ConvStr = .ReadText
    	.Close
    End With
    Set objStream = Nothing
End Function


'תΪָʽַ
Function BytesToBstr(strBody As Variant,outCode As String) As String
    Dim objStream As Object
    If LenB(strBody) = 0 Or outCode = "" Then Exit Function
    On Error Resume Next
    Set objStream = CreateObject("Adodb.Stream")
    If objStream Is Nothing Then
    	Err.Source = "Adodb.Stream"
    	Call sysErrorMassage(Err)
    	Exit Function
    End If
    On Error GoTo 0
    With objStream
    	.Type = 1
    	.Mode = 3
    	.Open
    	.Write strBody
    	.Position = 0
    	.Type = 2
    	.Charset = outCode
    	BytesToBstr = .ReadText
    	.Close
    End With
    Set objStream = Nothing
End Function


'дݵļ
Function BytesToFile(strBody As Variant,File As String) As Boolean
	Dim objStream As Object
	BytesToFile = False
	If LenB(strBody) = 0 Or File = "" Then Exit Function
	On Error Resume Next
    Set objStream = CreateObject("Adodb.Stream")
    If objStream Is Nothing Then
    	Err.Source = "Adodb.Stream"
    	Call sysErrorMassage(Err)
    	Exit Function
    End If
    On Error GoTo 0
    With objStream
		.Type = 1
		.Mode = 3
		.Open
		.Write(strBody)
		.Position = 0
		.SaveToFile File,2
		.Flush
		.Close
	End With
	Set objStream = Nothing
	BytesToFile = True
End Function


' XML ʽȡı
Function ReadXML(xmlObj As Object,IdNames As String,TagNames As String) As String
	Dim xmlDoc As Object,Node As Object,Item As Object,IdName As String,TagName As String
	Dim x As Long,y As Long,i As Long,Max As Long
	If xmlObj Is Nothing Then Exit Function
	If IdNames = "" And TagNames = "" Then Exit Function

	On Error Resume Next
	Set xmlDoc = CreateObject("Microsoft.XMLDOM")
	If xmlDoc Is Nothing Then
		Err.Source = "Microsoft.XMLDOM"
		Call sysErrorMassage(Err)
		Exit Function
	End If
	On Error GoTo 0
	'xmlDoc.Async = False
	'xmlDoc.ValidateOnParse = False
	'xmlDoc.loadXML(xmlObj)	'ִ
	xmlDoc.Load(xmlObj)		'ض
  	If xmlDoc.ReadyState > 2 Then
  		IdNameArray = Split(Convert(IdNames),"|")
		TagNameArray = Split(Convert(TagNames),"|")
		For x = 0 To UBound(IdNameArray)
			For y = 0 To UBound(TagNameArray)
				IdName = IdNameArray(x)
				TagName = TagNameArray(y)
				If IdName <> "" And TagName = "" Then
					On Error Resume Next
					Set Item = xmlDoc.getElementById(IdName)
					If Item Is Nothing Then
						Set Item = xmlDoc.getElementsByTagName(IdName)
					End If
					On Error GoTo 0
				ElseIf IdName <> "" And TagName <> "" Then
					On Error Resume Next
					Set Node = xmlDoc.getElementById(IdName)
					If Node Is Nothing Then
						Set Item = xmlDoc.getElementsByTagName(TagName)
					Else
						Set Item = Node.getElementsByTagName(TagName)
						If Item.Length = 0 Then Set Item = xmlDoc.getElementById(IdName)
					End If
					On Error GoTo 0
				ElseIf IdName = "" And TagName <> "" Then
					Set Item = xmlDoc.getElementsByTagName(TagName)
				End If
				Max = Item.Length
				If Max > 0 Then Exit For
			Next y
			If Max > 0 Then Exit For
		Next x
		If Max > 0 Then
			For i = 0 To Max-1
				If ReadXML <> "" Then ReadXML = ReadXML & Item(i).Text
				If ReadXML = "" Then ReadXML = Item(i).Text    'firstChild.nodeValue
			Next i
		End If
	End If
	Set xmlDoc = Nothing
End Function


'ȡָǰֵַ֮
Function ExtractStr(textStr As String,BeforeStr As String,AfterStr As String,fType As Long) As String
	Dim i As Long,x As Long,y As Long,L1 As Long,L2 As Long
	Dim Temp As String,bStr As String,aStr As String,toFindText As String

	If Trim(textStr) = "" Or (BeforeStr = "" And AfterStr = "") Then Exit Function
	toFindText = textStr & vbCrLf
	BeforeStrArray = Split(Convert(BeforeStr),"|")
	AfterStrArray = Split(Convert(AfterStr),"|")
	For x = 0 To UBound(BeforeStrArray)
		For y = 0 To UBound(AfterStrArray)
			L1 = 1
			For i = 0 To 1
				bStr = BeforeStrArray(x)
				aStr = AfterStrArray(y)
				L1 = InStr(L1,toFindText,bStr)
				If L1 > 0 Then
					L1 = L1 + Len(bStr)
					L2 = InStr(L1,toFindText,aStr)
					If fType > 0 And L2 = 0 Then L2 = InStr(L1,toFindText,vbCrLf)
					If L2 <> 0 Then
						Temp = Mid(toFindText,L1,L2-L1)
						If ExtractStr <> "" Then ExtractStr = ExtractStr & Temp
						If ExtractStr = "" Then ExtractStr = Temp
					End If
					If fType > 0 And i + 1 = fType Then Exit For
					i = 0
				Else
					Exit For
				End If
			Next i
			If ExtractStr <> "" Then Exit For
		Next y
		If ExtractStr <> "" Then Exit For
	Next x
End Function


'ִǷֺͷ
Function CheckStr(textStr As String,AscRange As String) As Boolean
	Dim i As Long,j As Long,n As Long,InpAsc As Long,Length As Long,Max As Long
	Dim pos As Long,MinV As Long,MaxV As Long,Temp As String,Stemp As Boolean
	CheckStr = False
	If Trim(textStr) = "" Or AscRange = "" Then Exit Function
	n = 0
	Stemp = False
	Length = Len(textStr)
	For i = 1 To Length
		InpAsc = AscW(Mid(textStr,i,1))
		AscValue = Split(AscRange,",",-1)
		Max = UBound(AscValue)
		For j = 0 To Max
			Temp = AscValue(j)
			pos = InStr(Temp,"-")
			If pos <> 0 Then
				MinV = CLng(Left(Temp,pos-1))
				MaxV = CLng(Mid(Temp,pos+1))
			Else
				MinV = CLng(Temp)
				MaxV = CLng(Temp)
			End If
			If InpAsc >= MinV And InpAsc <= MaxV Then
				n = n + 1
				Exit For
			Else
				If j = Max Then Stemp = True
			End If
		Next j
		If Stemp = True Then Exit For
	Next i
	If n = Length Then CheckStr = True
End Function


'з봦
Function SplitTran(xmlHttp As Object,srcStr As String,LangPair As String,Arg As String,fType As Long) As String
	Dim i As Long,srcStrBak As String,srcStringBak As String,Temp As String,Stemp As Boolean
	Dim EngineID As Long,CheckID As Long,mAccKey As Long,mAccelerator As Long,mHanding As Long

	If Trim(srcStr) = "" Or LangPair = "" Or Arg = "" Then Exit Function
	TempArray = Split(Arg,JoinStr,-1)
	EngineID = StrToLong(TempArray(0))
	CheckID = StrToLong(TempArray(1))
	mAccKey = StrToLong(TempArray(2))
	mAccelerator = StrToLong(TempArray(3))
	mHanding = StrToLong(TempArray(4))

	'滻ִ
	srcStrBak = srcStr
	LineSplitChar = "\r\n,\r,\n"
	FindStrArr = Split(Convert(LineSplitChar),",",-1)
	For i = LBound(FindStrArr) To UBound(FindStrArr)
		FindStr = Trim(FindStrArr(i))
		If InStr(srcStrBak,FindStr) Then
			srcStrBak = Replace(srcStrBak,FindStr,"*c!N!g*")
		End If
	Next i
	srcStrArr = Split(srcStrBak,"*c!N!g*",-1)

	'ȡÿеķ
	Temp = srcStr
	Stemp = False
	For i = LBound(srcStrArr) To UBound(srcStrArr)
		srcString = srcStrArr(i)
		srcStringBak = srcString
		If srcString <> "" Then
			If mHanding = 0 Then
				If mAccKey = 1 Then srcString = AccessKeyHanding(CheckID,srcString)
				If mAccelerator = 1 Then srcString = AcceleratorHanding(CheckID,srcString)
				If srcString <> "" And srcString <> srcStringBak Then
					srcStr = Replace(srcStr,srcStringBak,srcString,,1)
				End If
			End If
			trnString = getTranslate(EngineID,xmlHttp,srcString,LangPair,fType)
			If trnString <> "" And trnString <> srcStringBak Then
				Temp = Replace(Temp,srcStringBak,trnString,,1)
				Stemp = True
			End If
		End If
	Next i
	If Stemp = True Then SplitTran = Temp
End Function


'ݼַ
Function AccessKeyHanding(CheckID As Long,srcStr As String) As String
	Dim i As Long,j As Long,n As Long,posin As Long,Stemp As Boolean
	Dim AccessKey As String,acckeyIFR As String,acckeySTR As String

	AccessKeyHanding = srcStr
	If InStr(srcStr,"&") = 0 Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	ExcludeChar = SetsArray(0)
	CheckBracket = SetsArray(2)

	'ųִеķǿݼ
	If ExcludeChar <> "" Then
		FindStrArr = Split(Convert(ExcludeChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = LTrim(FindStrArr(i))
			If FindStr <> "" Then
				AccessKeyHanding = Replace(AccessKeyHanding,FindStr,"*a" & i & "!N!" & i & "d*")
			End If
		Next i
	End If

	'ȡԭĺͷĿݼλüַ
	If InStr(srcStr,"&") Then
		i = InStrRev(srcStr,"&amp;")
		j = 0
		If i <> 0 Then
			Temp = Replace(srcStr,"&amp;","samp;")
			j = InStrRev(Temp,"&")
		Else
			j = InStrRev(srcStr,"&")
		End If
		If j <> 0 Then
			posin = j
			acckeyIFR = "&"
			acckeySTR = Mid(srcStr,j + 1,1)
		ElseIf i <> 0 Then
			posin = i
			acckeyIFR  = "&amp;"
			acckeySTR = Mid(srcStr,i + 5,1)
		End If
	End If

	'ȡݼȥ
	If posin > 1 Then
		If CheckBracket <> "" Then
			FindStrArr = Split(Convert(CheckBracket),",",-1)
			For i = LBound(FindStrArr) To UBound(FindStrArr)
				FindStr = Trim(FindStrArr(i))
				If FindStr <> "" Then
					LFindStr = Trim(Left(FindStr,1))
					RFindStr = Trim(Right(FindStr,1))
					For n = 0 To 1
						Stemp = False
						If InStrRev(AccessKeyHanding,LFindStr & acckeyIFR & acckeySTR & RFindStr) Then
							AccessKey = LFindStr & acckeyIFR & acckeySTR & RFindStr
							AccessKeyHanding = Replace(AccessKeyHanding,AccessKey,"")
						Else
							PreStr = Left(AccessKeyHanding,posin-1)
							AppStr = Mid(AccessKeyHanding,posin)
							AccessKeyHanding = PreStr & Replace(AppStr,acckeyIFR,"",,1)
						End If
						If posin > 1 Then
							posin = InStrRev(AccessKeyHanding,"&",posin - 1)
							If posin > 1 Then n = 0
							If posin <= 1 Then Exit For
						End If
					Next n
				End If
				If posin = 1 Then AccessKeyHanding = Replace(AccessKeyHanding,acckeyIFR,"",,1)
				If posin <= 1 Then Exit For
			Next i
		Else
			AccessKeyHanding = Replace(AccessKeyHanding,acckeyIFR,"")
		End If
	ElseIf posin = 1 Then
		AccessKeyHanding = Replace(AccessKeyHanding,acckeyIFR,"")
	End If

	'ԭִбųķǿݼ
	If ExcludeChar <> "" Then
		FindStrArr = Split(Convert(ExcludeChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = LTrim(FindStrArr(i))
			If FindStr <> "" Then
				AccessKeyHanding = Replace(AccessKeyHanding,"*a" & i & "!N!" & i & "d*",FindStr)
			End If
		Next i
	End If
End Function


'ַ
Function AcceleratorHanding(CheckID As Long,srcStr As String) As String
	Dim i As Long,j As Long,x As Long,y As Long
	Dim Shortcut As String,ShortcutKey As String,FindStr As String

	AcceleratorHanding = srcStr
	If Trim(srcStr) = "" Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	CheckShortChar = SetsArray(8)
	CheckShortKey = SetsArray(9)
	KeepShortKey = SetsArray(10)

	'ȡ
	If CheckShortChar <> "" Then
		FindStrArr = Split(Convert(CheckShortChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" And Shortcut = "" Then
				x = UBound(Split(srcStr,FindStr,-1))
				y = 0
				If x = 1 Then
					If Left(LTrim(srcStr),Len(FindStr)) <> FindStr Then
						y = InStrRev(srcStr,FindStr)
					End If
				ElseIf x > 1 Then
					y = InStrRev(srcStr,FindStr)
				End If
				If y <> 0 Then
					ShortcutKey = Trim(Mid(srcStr,y+1))
					If Trim(ShortcutKey) = "+" Then
						Shortcut = Trim(Mid(srcStr,y))
					Else
						x = 0
						KeyArr = Split(ShortcutKey,"+",-1)
						For j = LBound(KeyArr) To UBound(KeyArr)
							x = x + CheckKeyCode(KeyArr(j),CheckShortKey)
						Next j
						If x <> 0 And x >= UBound(KeyArr) Then
							Shortcut = Trim(Mid(srcStr,y))
						End If
					End If
				End If
			End If
			If Shortcut <> "" Then Exit For
		Next i
	End If

	'ȥ
	If Shortcut <> "" Then
		x = InStrRev(srcStr,Shortcut)
		If x <> 0 Then AcceleratorHanding = Left(srcStr,x-1)
	End If
End Function


'滻ضַ
'fType = 0 滻¼滻ַ
'fType = 1 滻¼滻ַ
'fType = 2 ԭ滻¼滻ַ
Function ReplaceStr(CheckID As Long,trnStr As String,fType As Long) As String
	Dim i As Long,PreStr As String,AppStr As String
	ReplaceStr = trnStr
	If Trim(trnStr) = "" Then Exit Function
	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	If fType <> 0 Then AutoRepChar = SetsArray(11) Else AutoRepChar = SetsArray(12)
	PreRepStr = ""
	AppRepStr = ""
	If AutoRepChar <> "" Then
		FindStrArr = Split(AutoRepChar,",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = FindStrArr(i)
			PreStr = ""
			AppStr = ""
			If InStr(FindStr,"|") Then
				TempArray = Split(FindStr,"|")
				If fType < 2 Then
					PreStr = TempArray(0)
					AppStr = TempArray(1)
				Else
					PreStr = TempArray(1)
					AppStr = TempArray(0)
				End If
				cPreStr = Convert(PreStr)
				cAppStr = Convert(AppStr)
			End If
			If PreStr <> "" And InStr(ReplaceStr,cPreStr) Then
				ReplaceStr = Replace(ReplaceStr,cPreStr,cAppStr)
				If fType = 0 Then
					If PreRepStr <> "" Then
						If InStr(PreRepStr,PreStr) = 0 Then PreRepStr = PreRepStr & JoinStr & PreStr
					Else
						PreRepStr = PreStr
					End If
					If AppRepStr <> "" Then
						If InStr(AppRepStr,AppStr) = 0 Then AppRepStr = AppRepStr & JoinStr & AppStr
					Else
						AppRepStr = AppStr
					End If
				End If
			End If
		Next i
	End If
End Function


'ݼֹͼ
Function CheckHanding(CheckID As Long,srcStr As String,trnStr As String) As String
	Dim i As Long,BaksrcStr As String,BaktrnStr As String,AccessKeyHanding As String,trnStrBak As String
	Dim srcNum As Long,trnNum As Long,srcSplitNum As Long,trnSplitNum As Long
	Dim FindStrArr() As String,srcStrArr() As String,trnStrArr() As String,LineSplitArr() As String
	Dim posinSrc As Long,posinTrn As Long

	CheckHanding = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	ExcludeChar = SetsArray(0)
	LineSplitChar = SetsArray(1)
	KeepCharPair = SetsArray(3)

	'ַ
	If LineSplitChar <> "" Then
		FindStrArr = Split(LineSplitChar,",",-1)
		FindStrArr = SortArray(FindStrArr,0,"Lenght",">")
		LineSplitChar = Join(FindStrArr,",")
	End If

	'ʼ
	srcNum = 0
	trnNum = 0
	srcSplitNum = 0
	trnSplitNum = 0
	BaksrcStr = srcStr
	BaktrnStr = trnStr
	posinSrc = InStrRev(srcStr,"&")
	posinTrn = InStrRev(trnStr,"&")

	'ųִеķǿݼ
	If (posinSrc <> 0 Or posinTrn <> 0) And ExcludeChar <> "" Then
		FindStrArr = Split(Convert(ExcludeChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = LTrim(FindStrArr(i))
			If FindStr <> "" Then
				If posinSrc <> 0 Then
					BaksrcStr = Replace(BaksrcStr,FindStr,"*a" & i & "!N!" & i & "d*")
				End If
				If posinTrn <> 0 Then
					BaktrnStr = Replace(BaktrnStr,FindStr,"*a" & i & "!N!" & i & "d*")
				End If
			End If
		Next i
	End If

	'˲ǿݼĿݼ
	If (posinSrc <> 0 Or posinTrn <> 0) And KeepCharPair <> "" Then
		FindStrArr = Split(Convert(KeepCharPair),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" Then
				LFindStr = Trim(Left(FindStr,1))
				RFindStr = Trim(Right(FindStr,1))
				ToRepStr = LFindStr & "&" & RFindStr
				BeRepStr = LFindStr & "*!N!" & i & "!M!" & i & "!N!*" & RFindStr
				If posinSrc <> 0 Then BaksrcStr = Replace(BaksrcStr,ToRepStr,BeRepStr)
				If posinTrn <> 0 Then BaktrnStr = Replace(BaktrnStr,ToRepStr,BeRepStr)
			End If
		Next i
	End If

	'滻ִ
	If LineSplitChar <> "" Then
		srcStrBak = BaksrcStr
		trnStrBak = BaktrnStr
		FindStrArr = Split(Convert(LineSplitChar),",",-1)
		For i = UBound(FindStrArr) To LBound(FindStrArr) Step -1
			FindStr = Trim(FindStrArr(i))
			If InStr(BaksrcStr,FindStr) Then srcNum = UBound(Split(BaksrcStr,FindStr,-1))
			If InStr(BaktrnStr,FindStr) Then trnNum = UBound(Split(BaktrnStr,FindStr,-1))
			If srcNum = trnNum And srcNum <> 0 And trnNum <> 0 Then
				If FindStr <> "&" Then
					srcStrBak = Replace(srcStrBak,FindStr,"*c!N!g*")
					trnStrBak = Replace(trnStrBak,FindStr,"*c!N!g*")
				ElseIf FindStr = "&" Then
					srcStrBak = Insert(srcStrBak,FindStr,"*c!N!g*",0)
					trnStrBak = Insert(trnStrBak,FindStr,"*c!N!g*",1)
				End If
			End If
		Next i
	End If
	srcStrArr = Split(srcStrBak,"*c!N!g*",-1)
	trnStrArr = Split(trnStrBak,"*c!N!g*",-1)

	'ִ
	srcSplitNum = UBound(srcStrArr)
	trnSplitNum = UBound(trnStrArr)
	If srcSplitNum = 0 And trnSplitNum = 0 Then
		BaktrnStr = StringReplace(CheckID,BaksrcStr,BaktrnStr)
	ElseIf srcSplitNum <> 0 Or trnSplitNum <> 0 Then
		LineSplitArr = MergeArray(srcStrArr,trnStrArr)
		BaktrnStr = ReplaceStrSplit(CheckID,BaktrnStr,LineSplitArr)
	End If

	'ݼ
	If InStr(BaksrcStr,"&") Then srcAccKeyNum = UBound(Split(BaksrcStr,"&",-1)) + 1
	If InStr(BaktrnStr,"&") Then trnAccKeyNum = UBound(Split(BaktrnStr,"&",-1)) + 1

	'ԭǿݼĿݼ
	If (posinSrc <> 0 Or posinTrn <> 0) And KeepCharPair <> "" Then
		FindStrArr = Split(Convert(KeepCharPair),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" Then
				LFindStr = Trim(Left(FindStr,1))
				RFindStr = Trim(Right(FindStr,1))
				ToRepStr = LFindStr & "*!N!" & i & "!M!" & i & "!N!*" & RFindStr
				BeRepStr = LFindStr & "&" & RFindStr
				If posinSrc <> 0 Then BaksrcStr = Replace(BaksrcStr,ToRepStr,BeRepStr)
				If posinTrn <> 0 Then BaktrnStr = Replace(BaktrnStr,ToRepStr,BeRepStr)
			End If
		Next i
	End If

	'ԭִбųķǿݼ
	If (posinSrc <> 0 Or posinTrn <> 0) And ExcludeChar <> "" Then
		FindStrArr = Split(Convert(ExcludeChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = LTrim(FindStrArr(i))
			If FindStr <> "" Then
				If posinSrc <> 0 Then
					BaksrcStr = Replace(BaksrcStr,"*a" & i & "!N!" & i & "d*",FindStr)
				End If
				If posinTrn <> 0 Then
					BaktrnStr = Replace(BaktrnStr,"*a" & i & "!N!" & i & "d*",FindStr)
				End If
			End If
		Next i
	End If
	CheckHanding = BaktrnStr
End Function


' лȡִĸֶβ滻ַ
Function StringReplace(CheckID As Long,srcStr As String,trnStr As String) As String
	Dim posinSrc As Long,posinTrn As Long,StringSrc As String,StringTrn As String
	Dim accesskeySrc As String,accesskeyTrn As String,acckeyIFRSrc As String,acckeyIFRTrn As String
	Dim ShortcutPosSrc As Long,ShortcutPosTrn As Long,PreTrn As String,Temp As String
	Dim EndStringPosSrc As Long,EndStringPosTrn As Long,AppTrn As String
	Dim preKeyTrn As String,appKeyTrn As String,Stemp As Boolean,FindStrArr() As String
	Dim i As Long,j As Long,x As Long,y As Long,m As Long,n As Long

	StringReplace = trnStr
	If Trim(srcStr) = "" Or Trim(trnStr) = "" Then Exit Function

	'ȡѡõĲ
	TempArray = Split(CheckDataList(CheckID),JoinStr)
	SetsArray = Split(TempArray(1),SubJoinStr)
	CheckBracket = SetsArray(2)
	AsiaKey = SetsArray(4)
	CheckEndChar = SetsArray(5)
	NoTrnEndChar = SetsArray(6)
	AutoTrnEndChar = SetsArray(7)
	CheckShortChar = SetsArray(8)
	CheckShortKey = SetsArray(9)
	KeepShortKey = SetsArray(10)

	'ַ
	If CheckEndChar <> "" Then
		FindStrArr = Split(CheckEndChar,-1)
		FindStrArr = SortArray(FindStrArr,0,"Lenght",">")
		CheckEndChar = Join(FindStrArr)
	End If

	'ʼ
	acckeySrc = ""
	acckeyTrn = ""
	ShortcutSrc = ""
	ShortcutTrn = ""
	EndStringSrc = ""
	EndStringTrn = ""
	ExpStringTrn = ""
	SpaceTrn = ""
	PreStringTrn = ""
	AppStringTrn = ""
	EndSpaceSrc = ""
	EndSpaceTrn = ""
	ShortcutPosSrc = 0
	ShortcutPosTrn = 0
	EndStringPosSrc = 0
	EndStringPosTrn = 0

	'ȡִĩβո
	EndSpaceSrc = Space(Len(srcStr) - Len(RTrim(srcStr)))
	EndSpaceTrn = Space(Len(trnStr) - Len(RTrim(trnStr)))

	'ȡ
	If CheckShortChar <> "" Then
		FindStrArr = Split(Convert(CheckShortChar),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" Then
				For n = 0 To 1
					If n = 0 Then Temp = srcStr
					If n = 1 Then Temp = trnStr
					x = UBound(Split(Temp,FindStr,-1))
					y = 0
					Shortcut = ""
					ShortcutPos = y
					If x = 1 Then
						If Left(LTrim(Temp),Len(FindStr)) <> FindStr Then
							y = InStrRev(Temp,FindStr)
						End If
					ElseIf x > 1 Then
						y = InStrRev(Temp,FindStr)
					End If
					If y <> 0 Then
						ShortcutKey = Trim(Mid(Temp,y+1))
						If Trim(ShortcutKey) = "+" Then
							If CheckKeyCode(ShortcutKey,CheckShortKey) <> 0 Then
								Shortcut = Trim(Mid(Temp,y))
								ShortcutPos = y
							End If
						Else
							x = 0
							KeyArr = Split(ShortcutKey,"+",-1)
							For j = LBound(KeyArr) To UBound(KeyArr)
								x = x + CheckKeyCode(KeyArr(j),CheckShortKey)
							Next j
							If x <> 0 And x >= UBound(KeyArr) Then
								Shortcut = Trim(Mid(Temp,y))
								ShortcutPos = y
							End If
						End If
						If n = 0 And ShortcutSrc = "" Then
							ShortcutSrc = Shortcut
							ShortcutPosSrc = ShortcutPos
						ElseIf n = 1 And ShortcutTrn = "" Then
							ShortcutTrn = Shortcut
							ShortcutPosTrn = ShortcutPos
						End If
					End If
				Next n
			End If
			If ShortcutSrc <> "" And ShortcutTrn <> "" Then Exit For
		Next i
	End If

	'ȡַֹᱻ
	If CheckEndChar <> "" Then
		FindStrArr = Split(Convert(CheckEndChar),-1)
		For i = UBound(FindStrArr) To LBound(FindStrArr) Step -1
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" Then
				If InStr(FindStr,"*") Or InStr(FindStr,"?") Or InStr(FindStr,"#") Then
					PreFindStr = Left(FindStr,1)
				Else
					PreFindStr = FindStr
				End If
				If PreFindStr <> "" Then
					For n = 0 To 1
						If n = 0 Then
							Temp = srcStr
							EndSpace = EndSpaceSrc
							Shortcut = ShortcutSrc
						ElseIf n = 1 Then
							Temp = trnStr
							EndSpace = EndSpaceTrn
							Shortcut = ShortcutTrn
						End If
						x = Len(Shortcut & EndSpace)
						If Len(Temp) > x Then Temp = Left(Temp,Len(Temp) - x)
						y = InStrRev(Temp,PreFindStr)
						EndString = ""
						EndStringPos = 0
						If y <> 0 Then
							PreStr = Left(Temp,y - 1)
							AppStr = Mid(Temp,y)
							x = Len(PreStr) - Len(RTrim(PreStr))
							If AppStr <> "" And Trim(AppStr) Like FindStr Then
								EndString = Space(x) & AppStr
								EndStringPos = y - x
								If n = 0 And EndStringSrc = "" Then
									EndStringSrc = EndString
									EndStringPosSrc = EndStringPos
								ElseIf n = 1 And EndStringTrn = "" Then
									EndStringTrn = EndString
									EndStringPosTrn = EndStringPos
								End If
							End If
						End If
					Next n
				End If
			End If
			If EndStringSrc <> "" And EndStringTrn <> "" Then Exit For
		Next i
	End If

	'ȡԭĺͷĿݼλüַ
	For i = 0 To 1
		If i = 0 Then Temp = srcStr
		If i = 1 Then Temp = trnStr
		If InStr(Temp,"&") Then
			x = InStrRev(Temp,"&amp;")
			y = 0
			j = 0
			If x <> 0 Then
				TempBak = Replace(Temp,"&amp;","samp;")
				y = InStrRev(TempBak,"&")
			Else
				y = InStrRev(Temp,"&")
			End If
			If y <> 0 Then
				j = y
				acckeyIFR = "&"
				acckeySTR = Mid(Temp,y + 1,1)
			ElseIf x <> 0 Then
				j = x
				acckeyIFR = "&amp;"
				acckeySTR = Mid(Temp,x + 5,1)
			End If
			If j <> 0 Then
				If i = 0 Then
					posinSrc = j
					acckeyIFRSrc = acckeyIFR
					accesskeySrc = acckeySTR
				Else
					posinTrn = j
					acckeyIFRTrn = acckeyIFR
					accesskeyTrn = acckeySTR
				End If
			End If
		End If
	Next i
	If acckeyIFRSrc = "" Then acckeyIFRSrc = "&"
	If acckeyIFRTrn = "" Then acckeyIFRTrn = "&"

	'ȡԭĺͷĿݼ (ݼǰַ)
	If (posinSrc <> 0 Or posinTrn <> 0) And CheckBracket <> "" Then
		FindStrArr = Split(Convert(CheckBracket),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If FindStr <> "" Then
				LFindStr = Trim(Left(FindStr,1))
				RFindStr = Trim(Right(FindStr,1))
				For n = 0 To 1
					If n = 0 Then
						Temp = srcStr
						j = posinSrc
						acckeyIFR = acckeyIFRSrc
						acckeySTR = accesskeySrc
					ElseIf n = 1 Then
						Temp = trnStr
						j = posinTrn
						acckeyIFR = acckeyIFRTrn
						acckeySTR = accesskeyTrn
					End If
					AccessKey = ""
					If j > 1 Then
						If InStrRev(Temp,LFindStr & acckeyIFR & acckeySTR & RFindStr) Then
							j = j - 1
							AccessKey = LFindStr & acckeyIFR & acckeySTR & RFindStr
						Else
							PreStr = Left(Temp,j - 1)
							AppStr = Mid(Temp,j + Len(acckeyIFR))
							x = Len(PreStr) - Len(RTrim(PreStr))
							y = Len(AppStr) - Len(LTrim(AppStr))
							If Right(RTrim(PreStr),1) = LFindStr And Left(LTrim(AppStr),1) = RFindStr Then
								j = j - x - 1
								AccessKey = Mid(Temp,j,x + y + Len(acckeyIFR) + 3)
							Else
								AccessKey = acckeyIFR
							End If
						End If
					ElseIf j = 1 Then
						AccessKey = acckeyIFR
					End If
					If n = 0 And acckeySrc = "" Then
						posinSrc = j
						acckeySrc = AccessKey
					ElseIf n = 1 And acckeyTrn = "" Then
						posinTrn = j
						acckeyTrn = AccessKey
					End If
				Next n
			End If
			If acckeySrc <> "" And acckeyTrn <> "" Then Exit For
		Next i
	Else
		If posinSrc <> 0 Then acckeySrc = acckeyIFRSrc
		If posinTrn <> 0 Then acckeyTrn = acckeyIFRTrn
	End If

	'ȡݼķֹͷǼַЩַƶݼǰ
	If posinTrn <> 0 Then
		x = Len(EndStringTrn & ShortcutTrn & EndSpaceTrn)
		If InStr(ShortcutTrn,acckeyIFRTrn) Then x = Len(EndSpaceTrn)
		If InStr(EndStringTrn,acckeyIFRTrn) Then x = Len(ShortcutTrn & EndSpaceTrn)
		If Len(trnStr) > x Then
			Temp = Left(trnStr,Len(trnStr) - x)
			ExpStringTrn = Mid(Temp,posinTrn + Len(acckeyTrn))
		End If
	End If

	'ȥݼֹǰĿո
	x = Len(acckeyTrn & ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn)
	If InStr(EndStringTrn & ShortcutTrn,acckeyIFRTrn) Then
		x = Len(ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn)
	End If
	If Len(trnStr) > x Then
		Temp = Left(trnStr,Len(trnStr) - x)
		y = Len(Temp) - Len(RTrim(Temp))
		SpaceTrn = Space(y)
		If y > 0 And ExpStringTrn <> "" Then
			If CheckStr(Left(Trim(ExpStringTrn),1),"0-255") = True Then SpaceTrn = Space(y-1)
		End If
	End If

	'ȡпݼǰֹ
	If (acckeySrc <> "" Or acckeyTrn <> "") And CheckEndChar <> "" Then
		x = Len(SpaceTrn & acckeyTrn & ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn)
		If InStr(EndStringTrn & ShortcutTrn,acckeyIFRTrn) Then
			x = Len(SpaceTrn & ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn)
		End If
		If Len(trnStr) > x Then
			Temp = Left(trnStr,Len(trnStr) - x)
			FindStrArr = Split(Convert(CheckEndChar),-1)
			For i = UBound(FindStrArr) To LBound(FindStrArr) Step -1
				FindStr = Trim(FindStrArr(i))
				If InStr(FindStr,"*") Or InStr(FindStr,"?") Or InStr(FindStr,"#") Then
					PreFindStr = Left(FindStr,1)
				Else
					PreFindStr = FindStr
				End If
				y = InStrRev(Temp,PreFindStr)
				If y <> 0 And PreFindStr <> "" Then
					PreStr = Left(Temp,y - 1)
					AppStr = Mid(Temp,y)
					x = Len(PreStr) - Len(RTrim(PreStr))
					If AppStr <> "" And Trim(AppStr) Like FindStr Then
						PreStringTrn = Space(x) & AppStr
					End If
				End If
				If PreStringTrn <> "" Then Exit For
			Next i
		End If
	End If

	'Զֹ
	If (EndStringSrc And AutoTrnEndChar) <> "" Then
		FindStrArr = Split(Convert(AutoTrnEndChar),-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If InStr(FindStr,"|") Then
				TempArray = Split(FindStr,"|")
				LFindStr = TempArray(0)
				RFindStr = TempArray(1)
				If Trim(EndStringSrc) = LFindStr Then
					EndStringSrc = RFindStr
					Exit For
				End If
			End If
		Next i
	End If

	'Ҫֹ
	If EndStringSrc <> "" And NoTrnEndChar <> "" Then
		PreEndStringSrc = Left(srcStr,EndStringPosSrc + Len(RTrim(EndStringSrc)))
		If CheckKeyCode(PreEndStringSrc,NoTrnEndChar) = 1 Then
			EndStringSrc = ""
		End If
	End If
	If EndStringTrn <> "" And NoTrnEndChar <> "" Then
		PreEndStringTrn = Left(trnStr,EndStringPosTrn + Len(RTrim(EndStringTrn)))
		If CheckKeyCode(PreEndStringTrn,NoTrnEndChar) = 1 Then
			EndStringTrn = ""
		End If
	End If

	'ļ
	If ShortcutSrc <> "" And ShortcutTrn <> "" And KeepShortKey <> "" Then
		srcNum = 0
		trnNum = 0
		If InStr(ShortcutSrc,"+") And Trim(ShortcutSrc) <> "+" Then
			SrcKeyArr = Split(ShortcutSrc,"+",-1)
			srcNum = UBound(SrcKeyArr)
		End If
		If InStr(ShortcutTrn,"+") And Trim(ShortcutTrn) <> "+" Then
			TrnKeyArr = Split(ShortcutTrn,"+",-1)
			trnNum = UBound(TrnKeyArr)
		End If
		If srcNum > trnNum Then Num = srcNum
		If srcNum < trnNum Then Num = trnNum
		If srcNum = trnNum Then Num = srcNum
		If srcNum <> 0 And trnNum <> 0 Then
			For i = 0 To Num
				SrcKey = ""
				TrnKey = ""
				If i <= srcNum Then SrcKey = Trim(SrcKeyArr(i))
				If i <= trnNum Then TrnKey = Trim(TrnKeyArr(i))
				If SrcKey <> "" And TrnKey <> "" Then
					If CheckKeyCode(TrnKey,KeepShortKey) <> 0 Then
						ShortcutSrc = Replace(ShortcutSrc,SrcKey,TrnKey)
					End If
				End If
			Next i
		End If
	End If

	'ִѡ
	If AllCont <> 1 Then
		If AccKey = 1 And EndChar = 1 And Acceler <> 1 Then
			ShortcutSrc = ShortcutTrn
		ElseIf AccKey = 1 And EndChar <> 1 And Acceler = 1 Then
			EndStringSrc = EndStringTrn
		ElseIf AccKey <> 1 And EndChar = 1 And Acceler = 1 Then
			SpaceTrn = ""
			ExpStringTrn = ""
			PreStringTrn = ""
			acckeySrc = acckeyTrn
		ElseIf AccKey = 1 And EndChar <> 1 And Acceler <> 1 Then
			EndStringSrc = EndStringTrn
			ShortcutSrc = ShortcutTrn
		ElseIf AccKey <> 1 And EndChar = 1 And Acceler <> 1 Then
			SpaceTrn = ""
			ExpStringTrn = ""
			PreStringTrn = ""
			acckeySrc = acckeyTrn
			ShortcutSrc = ShortcutTrn
		ElseIf AccKey <> 1 And EndChar <> 1 And Acceler = 1 Then
			SpaceTrn = ""
			ExpStringTrn = ""
			PreStringTrn = ""
			acckeySrc = acckeyTrn
			EndStringSrc = EndStringTrn
		End If
	End If

	'ݼ
	If AsiaKey = "1" Then
		StringSrc = acckeySrc & EndStringSrc & ShortcutSrc & EndSpaceSrc
		If InStr(EndStringTrn & ShortcutTrn,acckeyIFRTrn) Then
			ExpStringTrn = ""
			StringTrn = PreStringTrn & SpaceTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn
		Else
			StringTrn = PreStringTrn & SpaceTrn & acckeyTrn & ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn
		End If

		If acckeySrc <> "" Then acckeySrc = "(" & acckeyIFRSrc & UCase(accesskeySrc) & ")"
		If acckeyTrn = acckeyIFRTrn Then acckeyTrn = "(" & acckeyIFRTrn & UCase(accesskeyTrn) & ")"
		If InStr(ShortcutSrc,acckeyIFRSrc) Then ShortcutSrc = Replace(ShortcutSrc,acckeyIFRSrc,"")
		If Trim(PreStringTrn) <> "" And EndStringTrn = "" Then EndStringTrn = PreStringTrn

		If acckeySrc <> "" And EndStringSrc <> "" And ShortcutSrc <> "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeySrc & EndStringSrc & ShortcutSrc & EndSpaceSrc
		ElseIf acckeySrc = "" And EndStringSrc <> "" And ShortcutSrc <> "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeyTrn & EndStringSrc & ShortcutSrc & EndSpaceSrc
		ElseIf acckeySrc <> "" And EndStringSrc = "" And ShortcutSrc <> "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeySrc & RTrim(EndStringTrn) & ShortcutSrc & EndSpaceSrc
		ElseIf acckeySrc <> "" And EndStringSrc <> "" And ShortcutSrc = "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeySrc & EndStringSrc & ShortcutTrn & EndSpaceSrc

		ElseIf acckeySrc = "" And EndStringSrc = "" And ShortcutSrc <> "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeyTrn & RTrim(EndStringTrn) & ShortcutSrc & EndSpaceSrc
		ElseIf acckeySrc = "" And EndStringSrc <> "" And ShortcutSrc = "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeyTrn & EndStringSrc & ShortcutTrn & EndSpaceSrc
		ElseIf acckeySrc <> "" And EndStringSrc = "" And ShortcutSrc = "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeySrc & RTrim(EndStringTrn) & ShortcutTrn & EndSpaceSrc

		ElseIf acckeySrc = "" And EndStringSrc = "" And ShortcutSrc = "" Then
			NewStringTrn = Trim(ExpStringTrn) & acckeyTrn & RTrim(EndStringTrn) & ShortcutTrn & EndSpaceSrc
		End If
	Else
		If InStr(EndStringTrn & ShortcutTrn,acckeyIFRTrn) Then
			StringSrc = EndStringSrc & ShortcutSrc & EndSpaceSrc
			StringTrn = SpaceTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn
			If EndStringSrc <> "" And ShortcutSrc <> "" Then
				NewStringTrn = EndStringSrc & ShortcutSrc & EndSpaceSrc
			ElseIf EndStringSrc = "" And ShortcutSrc <> "" Then
				NewStringTrn = RTrim(EndStringTrn) & ShortcutSrc & EndSpaceSrc
			ElseIf EndStringSrc <> "" And ShortcutSrc = "" Then
				NewStringTrn = EndStringSrc & ShortcutTrn & EndSpaceSrc
			ElseIf EndStringSrc = "" And ShortcutSrc = "" Then
				NewStringTrn = RTrim(EndStringTrn) & ShortcutTrn & EndSpaceSrc
			End If
		Else
			StringSrc = acckeySrc & EndStringSrc & ShortcutSrc & EndSpaceSrc
			StringTrn = SpaceTrn & acckeyTrn & ExpStringTrn & EndStringTrn & ShortcutTrn & EndSpaceTrn
			If InStr(ShortcutSrc,acckeyIFRSrc) Then ShortcutSrc = Replace(ShortcutSrc,acckeyIFRSrc,"")
			If acckeySrc <> "" And EndStringSrc <> "" And ShortcutSrc <> "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & EndStringSrc & ShortcutSrc & EndSpaceSrc
			ElseIf acckeySrc = "" And EndStringSrc <> "" And ShortcutSrc <> "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & EndStringSrc & ShortcutSrc & EndSpaceSrc
			ElseIf acckeySrc <> "" And EndStringSrc = "" And ShortcutSrc <> "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & RTrim(EndStringTrn) & ShortcutSrc & EndSpaceSrc
			ElseIf acckeySrc <> "" And EndStringSrc <> "" And ShortcutSrc = "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & EndStringSrc & ShortcutTrn & EndSpaceSrc

			ElseIf acckeySrc = "" And EndStringSrc = "" And ShortcutSrc <> "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & RTrim(EndStringTrn) & ShortcutSrc & EndSpaceSrc
			ElseIf acckeySrc = "" And EndStringSrc <> "" And ShortcutSrc = "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & EndStringSrc & ShortcutTrn & EndSpaceSrc
			ElseIf acckeySrc <> "" And EndStringSrc = "" And ShortcutSrc = "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & RTrim(EndStringTrn) & ShortcutTrn & EndSpaceSrc

			ElseIf acckeySrc = "" And EndStringSrc = "" And ShortcutSrc = "" Then
				NewStringTrn = acckeyTrn & Trim(ExpStringTrn) & RTrim(EndStringTrn) & ShortcutTrn & EndSpaceSrc
			End If
		End If
		If acckeySrc <> "" Then acckeySrc = acckeyIFRSrc & accesskeySrc
		If acckeyTrn = acckeyIFRTrn Then acckeyTrn = acckeyIFRTrn & accesskeyTrn
		'If LCase(acckeySrc) = LCase(acckeyTrn) Then acckeySrc = acckeyTrn
		If InStr(ShortcutSrc,acckeyIFRSrc) Then ShortcutSrc = Replace(ShortcutSrc,acckeyIFRSrc,"")
		If InStr(ShortcutTrn,acckeyIFRTrn) Then ShortcutTrn = Replace(ShortcutTrn,acckeyIFRTrn,"")
		ExpStringTrn = ""
	End If

	'PSL.Output "------------------------------ "      '
	'PSL.Output "srcStr = " & srcStr                   '
	'PSL.Output "trnStr = " & trnStr                   '
	'PSL.Output "SpaceTrn = " & SpaceTrn               '
	'PSL.Output "acckeySrc = " & acckeySrc             '
	'PSL.Output "acckeyTrn = " & acckeyTrn             '
	'PSL.Output "EndStringSrc = " & EndStringSrc       '
	'PSL.Output "EndStringTrn = " & EndStringTrn       '
	'PSL.Output "ShortcutSrc = " & ShortcutSrc         '
	'PSL.Output "ShortcutTrn = " & ShortcutTrn         '
	'PSL.Output "ExpStringTrn = " & ExpStringTrn       '
	'PSL.Output "StringSrc = " & StringSrc             '
	'PSL.Output "StringTrn = " & StringTrn             '
	'PSL.Output "NewStringTrn = " & NewStringTrn       '
	'PSL.Output "PreStringTrn = " & PreStringTrn       '

	'ִ滻
	If StringSrc <> StringTrn Then
		If StringTrn <> "" And StringTrn <> NewStringTrn Then
			x = InStrRev(StringReplace,StringTrn)
			If x <> 0 Then
				PreTrn = Left(StringReplace,x - 1)
				AppTrn = Mid(StringReplace,x)
				'PSL.Output "PreTrn = " & PreTrn       '
				'PSL.Output "AppTrn = " & AppTrn       '
				StringReplace = PreTrn & Replace(AppTrn,StringTrn,NewStringTrn)
			Else
				StringReplace = Replace(StringReplace,StringTrn,NewStringTrn)
			End If
		ElseIf StringTrn = "" And NewStringTrn <> "" Then
			StringReplace = RTrim(StringReplace) & NewStringTrn
		End If
	End If
	If AsiaKey <> "1" Then
		If acckeyTrn <> "" And acckeyTrn <> acckeyIFRTrn & accesskeyTrn Then
			StringReplace = Replace(StringReplace,acckeyTrn,"")
		End If
		If acckeySrc <> "" And acckeySrc <> acckeyTrn Then
			posinTrn = InStr(StringReplace,accesskeySrc)
			If posinTrn = 0 Then posinTrn = InStr(UCase(StringReplace),UCase(accesskeySrc))
			If posinTrn <> 0 Then
				keyTrn = Mid(StringReplace,posinTrn,1)
				keySrc = acckeyIFRSrc & keyTrn
				If acckeyTrn = "" Then StringReplace = Replace(StringReplace,keyTrn,keySrc,,1)
				If acckeyTrn <> "" And acckeyTrn <> keySrc Then
					StringReplace = Replace(StringReplace,acckeyTrn,accesskeyTrn)
					StringReplace = Replace(StringReplace,keyTrn,keySrc,,1)
				End If
			Else
				If acckeyTrn = "" Then StringReplace = acckeyIFRSrc & StringReplace Else acckeyTrn = acckeySrc
			End If
		End If
	End If
End Function


'Ϣ
Sub sysErrorMassage(sysError As ErrObject)
	Dim TranCount As Long,TempArray() As String,MsgList() As String
	Dim ErrorNumber As Long,ErrorSource As String,ErrorDescription As String

	ErrorNumber = sysError.Number
	ErrorSource = sysError.Source
	ErrorDescription = sysError.Description

	ItemList$ = "sysErrorMassage"
	If getMsgList(UILangList,MsgList,ItemList$,0) = False Then
		If ErrorSource = "NotSection" Then
			If getMsgList(UILangList,MsgList,"Main",0) = False Then
				Msg = "The following file is missing [Main] section."
				PSL.Output("Error: " & Msg & vbCrLf & LangFile)
			Else
				Msg = Replace(MsgList(75),"%s",ItemList$)
				Msg = Replace(Msg,"%d",LangFile)
				PSL.Output(MsgList(42) & ": " & Msg)
			End If
			Exit Sub
		End If
	End If

	If ErrorSource = "" Then
		Msg = MsgList(1) & vbCrLf & MsgList(4)
		PSL.Output(MsgList(0) & ": " & Msg & CStr(ErrorNumber) & ", " & ErrorDescription)
	ElseIf ErrorSource = "NotSection" Then
		TempArray = Split(ErrorDescription,JoinStr,-1)
		Msg = Replace(MsgList(3),"%s",TempArray(1))
		Msg = Replace(Msg,"%d",TempArray(0))
		PSL.Output(MsgList(0) & ": " & Msg)
	Else
		Msg = Replace(MsgList(2),"%s",ErrorSource) & vbCrLf & MsgList(4)
		PSL.Output(MsgList(0) & ": " & Msg & CStr(ErrorNumber) & ", " & ErrorDescription)
	End If
End Sub


'ڿݼضַԴ˲ִ
Function Insert(SplitString As String,SplitStr As String,InsStr As String,Leng As Long) As String
	Dim StartNum As Long,EndNum As Long,i As Long,oldLeng As Long
	Dim newLeng As Long,accesskeyStr As String
	Insert = SplitString
	If UBound(Split(SplitString,SplitStr)) < 2 Then Exit Function
	StartNum = InStr(Insert,SplitStr)
	EndNum = InStrRev(Insert,SplitStr)
	If StartNum < EndNum Then
		For i = StartNum To EndNum
			If Mid(Insert,i,Len(SplitStr)) = SplitStr Then
				oldLeng = InStr(Mid(Insert,i+Len(SplitStr)),SplitStr)
				newLeng = InStr(Mid(Insert,i+Len(SplitStr)),InsStr)
				accesskeyStr = ""
				If oldLeng <> 0 And newLeng <> 0 And oldLeng > newLeng Then
					accesskeyStr = ""
				ElseIf oldLeng <> 0 And newLeng <> 0 And oldLeng < newLeng And i > Leng Then
					accesskeyStr = Mid(Insert,i-Leng,oldLeng)
				ElseIf oldLeng = 0 And newLeng <> 0 And i > Leng Then
					accesskeyStr = Mid(Insert,i-Leng,newLeng)
				ElseIf oldLeng <> 0 And newLeng = 0 And i > Leng  Then
					accesskeyStr = Mid(Insert,i-Leng,oldLeng)
				ElseIf oldLeng = 0 And newLeng = 0 And i > Leng  Then
					accesskeyStr = Mid(Insert,i-Leng)
				End If
				If accesskeyStr <> "" Then
					Insert = Replace(Insert,accesskeyStr,accesskeyStr & InsStr)
				End If
				i = i + oldLeng
			End If
		Next i
	End If
	'PSL.Output "Insert = " & Insert       '
End Function


'ϲ
Function MergeArray(srcStrArr() As String,trnStrArr() As String) As Variant
	Dim i As Long,srcNum As Long,trnNum As Long
	Dim srcPassNum As Long,trnPassNum As Long
	srcNum = UBound(srcStrArr)
	trnNum = UBound(trnStrArr)
	srcPassNum = 0
	trnPassNum = 0
	Dim TempArray() As String
	For i = 0 To (srcNum + trnNum + 1) Step 2
		ReDim Preserve TempArray(i)
		If srcNum >= srcPassNum Then
			TempArray(i) = srcStrArr(srcPassNum)
			srcPassNum = srcPassNum + 1
		ElseIf srcNum < srcPassNum Then
			TempArray(i) = ""
		End If
		ReDim Preserve TempArray(i+1)
		If trnNum >= trnPassNum Then
			TempArray(i+1) = trnStrArr(trnPassNum)
			trnPassNum = trnPassNum + 1
		ElseIf trnNum < trnPassNum Then
			TempArray(i+1) = ""
		End If
	Next i
	MergeArray = TempArray
End Function


'ִת
Function ReConvert(ConverString As String) As String
	ReConvert = ConverString
	If ReConvert = "" Then Exit Function
	If InStr(ReConvert,vbCrLf) Then ReConvert = Replace(ReConvert,vbCrLf,"\r\n")
	If InStr(ReConvert,vbNewLine) Then ReConvert = Replace(ReConvert,vbNewLine,"\r\n")
	If InStr(ReConvert,vbCr) Then ReConvert = Replace(ReConvert,"\r",vbCr)
	If InStr(ReConvert,vbNewLine) Then ReConvert = Replace(ReConvert,vbNewLine,"\r")
	If InStr(ReConvert,vbLf) Then ReConvert = Replace(ReConvert,vbLf,"\n")
	If InStr(ReConvert,vbBack) Then ReConvert = Replace(ReConvert,vbBack,"\b")
	If InStr(ReConvert,vbFormFeed) Then ReConvert = Replace(ReConvert,vbFormFeed,"\f")
	If InStr(ReConvert,vbVerticalTab) Then ReConvert = Replace(ReConvert,vbVerticalTab,"\v")
	If InStr(ReConvert,vbTab) Then ReConvert = Replace(ReConvert,vbTab,"\t")
	'If InStr(ReConvert,vbNullChar) Then ReConvert = Replace(ReConvert,vbNullChar,"\0")
	'If InStr(ReConvert,"\") Then ReConvert = Replace(ReConvert,"\","\\")
End Function


'ִת
Function Convert(ConverString As String) As String
	Convert = ConverString
	If Convert = "" Then Exit Function
	If InStr(Convert,"\") = 0 Then Exit Function
	If InStr(Convert,"\\") Then Convert = Replace(Convert,"\\","*a!N!d*")
	If InStr(Convert,"\r\n") Then Convert = Replace(Convert,"\r\n",vbCrLf)
	If InStr(Convert,"\r\n") Then Convert = Replace(Convert,"\r\n",vbNewLine)
	If InStr(Convert,"\r") Then Convert = Replace(Convert,"\r",vbCr)
	If InStr(Convert,"\r") Then Convert = Replace(Convert,"\r",vbNewLine)
	If InStr(Convert,"\n") Then Convert = Replace(Convert,"\n",vbLf)
	If InStr(Convert,"\b") Then Convert = Replace(Convert,"\b",vbBack)
	If InStr(Convert,"\f") Then Convert = Replace(Convert,"\f",vbFormFeed)
	If InStr(Convert,"\v") Then Convert = Replace(Convert,"\v",vbVerticalTab)
	If InStr(Convert,"\t") Then Convert = Replace(Convert,"\t",vbTab)
	If InStr(Convert,"\'") Then Convert = Replace(Convert,"\'","'")
	If InStr(Convert,"\""") Then Convert = Replace(Convert,"\""","""")
	If InStr(Convert,"\?") Then Convert = Replace(Convert,"\?","?")
	If InStr(Convert,"\") Then Convert = ConvertB(Convert)
	If InStr(Convert,"\0") Then Convert = Replace(Convert,"\0",vbNullChar)
	If InStr(Convert,"*a!N!d*") Then Convert = Replace(Convert,"*a!N!d*","\")
End Function


'ת˽ƻʮת
Function ConvertB(ConverString As String) As String
	Dim i As Long,EscStr As String,ConvCode As String
	Dim ConvString As String,Stemp As Boolean
	ConvertB = ConverString
	If ConvertB = "" Then Exit Function
	i = InStr(ConvertB,"\")
	Do While i <> 0
		EscStr = Mid(ConvertB,i,2)
		Stemp = False

		If EscStr = "\x" Then
			ConvCode = Mid(ConvertB,i+2,2)
			Stemp = CheckStr(UCase(ConvCode),"48-57,65-70")
		ElseIf EscStr = "\u" Then
			ConvCode = Mid(ConvertB,i+2,4)
			Stemp = CheckStr(UCase(ConvCode),"48-57,65-70")
		ElseIf EscStr = "\U" Then
			ConvCode = Mid(ConvertB,i+2,4)
			Stemp = CheckStr(UCase(ConvCode),"48-57,65-70")
		ElseIf EscStr <> "" Then
			EscStr = "\"
			ConvCode = Mid(ConvertB,i+1,3)
			Stemp = CheckStr(ConvCode,"48-55")
		End If

		If Stemp = True Then
			If EscStr = "\x" Then ConvString = ChrW(Val("&H" & ConvCode))
			If LCase(EscStr) = "\u" Then ConvString = ChrW(Val("&H" & ConvCode))
			If EscStr = "\" Then ConvString = ChrW(Val("&O" & ConvCode))
			If ConvString <> "" Then
				ConvertB = Replace(ConvertB,EscStr & ConvCode,ConvString)
				i = 0
			End If
		End If

		i = InStr(i+1,ConvertB,"\")
		If i = 0 Then Exit Do
	Loop
End Function


'תַΪֵ
Function StrToLong(mStr As String) As Long
	If mStr = "" Then mStr = "0"
	StrToLong = CLng(mStr)
End Function


'ȡеÿִ滻
Function ReplaceStrSplit(CheckID As Long,trnStr As String,StrSplitArr() As String) As String
	Dim srcStrSplit As String,trnStrSplit As String,trnStrSplitNew As String,TacckeySrc As String
	Dim TEndStringSrc As String,TShortcutSrc As String,TSpaceTrn As String,TacckeyTrn As String
	Dim TExpStringTrn As String,TEndStringTrn As String,TShortcutTrn As String,TStringSrc As String
	Dim TStringTrn As String,TPreStringTrn As String,TEndSpaceSrc As String,TEndSpaceTrn As String

	ReplaceStrSplit = trnStr
	If Trim(trnStr) = "" Then Exit Function
	TacckeySrc = ""
	TEndStringSrc = ""
	TShortcutSrc = ""
	TSpaceTrn = ""
	TacckeyTrn = ""
	TExpStringTrn = ""
	TEndStringTrn = ""
	TShortcutTrn = ""
	TPreStringTrn = ""
	TEndSpaceSrc = ""
	TEndSpaceTrn = ""

	For i = 0 To UBound(StrSplitArr) Step 2
		srcStrSplit = StrSplitArr(i)
		trnStrSplit = StrSplitArr(i+1)
		trnStrSplitNew = StringReplace(CheckID,srcStrSplit,trnStrSplit)
		ReplaceStrSplit = Replace(ReplaceStrSplit,trnStrSplit,trnStrSplitNew,,1)

		'ÿеݽӣϢ
		TacckeySrc = TacckeySrc & acckeySrc
		TEndStringSrc = TEndStringSrc & EndStringSrc
		TShortcutSrc = TShortcutSrc & ShortcutSrc
		TSpaceTrn = TSpaceTrn & SpaceTrn
		TacckeyTrn = TacckeyTrn & acckeyTrn
		TExpStringTrn = TExpStringTrn & ExpStringTrn
		TEndStringTrn = TEndStringTrn & EndStringTrn
		TShortcutTrn = TShortcutTrn & ShortcutTrn
		TPreStringTrn = TPreStringTrn & PreStringTrn
		TEndSpaceSrc = TEndSpaceSrc & EndSpaceSrc
		TEndSpaceTrn = TEndSpaceTrn & EndSpaceTrn
	Next i

	'ΪϢԭб滻Ӻ
	acckeySrc = TacckeySrc
	EndStringSrc = TEndStringSrc
	ShortcutSrc = TShortcutSrc
	SpaceTrn = TSpaceTrn
	acckeyTrn = TacckeyTrn
	ExpStringTrn = TExpStringTrn
	EndStringTrn = TEndStringTrn
	ShortcutTrn = TShortcutTrn
	PreStringTrn = TPreStringTrn
	EndSpaceSrc = TEndSpaceSrc
	EndSpaceTrn = TEndSpaceTrn
End Function


'ȡ
Function EngineGet(SelSet As String,DataList() As String,Path As String) As Boolean
	Dim i As Long,n As Long,Header As String,HeaderIDs As String,HeaderIDArr() As String,Temp As String
	EngineGet = False
	NewVersion = ToUpdateEngineVersion
	NewSet = SelSet

	If Path = EngineRegKey Then GoTo GetFromRegistry
	If Path = "" Then Path = EngineFilePath
	If Dir(Path) = "" Then GoTo GetFromRegistry
	On Error GoTo GetFromRegistry
	LineArray = Split(ReadFile(Path,"_autodetect_all"),vbCrLf)
	n = UBound(LineArray)
	For i = LBound(LineArray) To UBound(LineArray)
		L$ = LineArray(i)
		If Left(Trim(L$),1) = "[" And Right(Trim(L$),1) = "]" Then
			Header = Mid(Trim(L$),2,Len(Trim(L$))-2)
		End If
		If L$ <> "" And Header <> "" Then
			setPreStr = ""
			setAppStr = ""
			If InStr(L$,"=") Then setPreStr = Trim(Left(L$,InStr(L$,"=")-1))
			If InStr(L$,"=") Then setAppStr = LTrim(Mid(L$,InStr(L$,"=")+1))
			'ȡ Option ֵ
			If setPreStr = "Version" Then OldVersion = setAppStr
			If Header = "Option" And setPreStr <> "" Then
				If setPreStr = "CheckSet" Then CheckSet = setAppStr
				If setPreStr = "TranAllType" Then mAllType = setAppStr
				If setPreStr = "TranMenu" Then mMenu = setAppStr
				If setPreStr = "TranDialog" Then mDialog = setAppStr
				If setPreStr = "TranString" Then mString = setAppStr
				If setPreStr = "TranAcceleratorTable" Then mAccTable = setAppStr
				If setPreStr = "TranVersion" Then mVer = setAppStr
				If setPreStr = "TranOther" Then mOther = setAppStr
				If setPreStr = "TranSeletedOnly" Then mSelOnly = setAppStr
				If setPreStr = "SkipForReview" Then mForReview = setAppStr
				If setPreStr = "SkipValidated" Then mValidated = setAppStr
				If setPreStr = "SkipNotTran" Then mNotTran = setAppStr
				If setPreStr = "SkipAllNumAndSymbol" Then mNumAndSymbol = setAppStr
				If setPreStr = "SkipAllUCase" Then mAllUCase = setAppStr
				If setPreStr = "SkipAllLCase" Then mAllLCase = setAppStr
				If setPreStr = "AutoSelection" Then mAutoSele = setAppStr
				If setPreStr = "CheckAccessKey" Then mAccKey = setAppStr
				If setPreStr = "CheckAccelerator" Then mAccelerator = setAppStr
				If setPreStr = "CheckPreString" Then mPreStrRep = setAppStr
				If setPreStr = "CheckWebPageFlag" Then mWebFlag = setAppStr
				If setPreStr = "CheckTranslation" Then mCheckTrn = setAppStr
				If setPreStr = "AutoRepString" Then mAppStrRep = setAppStr
				If setPreStr = "KeepSetting" Then KeepSet = setAppStr
				If setPreStr = "ShowMassage" Then ShowMsg = setAppStr
				If setPreStr = "AddTranComment" Then TranComm = setAppStr
				If setPreStr = "UILanguageID" Then UILangID = setAppStr
				If SelSet = "" Then
					If setPreStr = "TranEngineSet" Then EngineSet = setAppStr
				End If
			End If
			'ȡ Option ȫֵ
			If Header <> "Option" And Header <> "Update" And setPreStr <> "" Then
				If setPreStr = "ObjectName" Then ObjName = setAppStr
				If setPreStr = "AppId" Then AppId = setAppStr
				If setPreStr = "EngineUrl" Then Url = setAppStr
				If setPreStr = "UrlTemplate" Then UrlTmp = setAppStr
				If setPreStr = "Method" Then Method = setAppStr
				If setPreStr = "Async" Then Async = setAppStr
				If setPreStr = "User" Then User = setAppStr
				If setPreStr = "Password" Then Pwd = setAppStr
				If setPreStr = "SendBody" Then Body = setAppStr
				If setPreStr = "RequestHeader" Then rHead = ReConvert(setAppStr)
				If setPreStr = "ResponseType" Then rType = setAppStr
				If setPreStr = "TranBeforeStr" Then bStr = setAppStr
				If setPreStr = "TranAfterStr" Then aStr = setAppStr
				If setPreStr = "Enable" Then Enable = setAppStr
				If setPreStr = "LangCodePair" Then LngPair = setAppStr
			End If
		End If
		If (L$ = "" Or i = n) And Header = "Option" Then
			Data = EngineSet & JoinStr & CheckSet & JoinStr & mAllType & JoinStr & mMenu & _
					JoinStr & mDialog & JoinStr & mString & JoinStr & mAccTable & JoinStr & _
					mVer & JoinStr & mOther & JoinStr & mSelOnly & JoinStr & mForReview & _
					JoinStr & mValidated & JoinStr & mNotTran & JoinStr & mNumAndSymbol & _
					JoinStr & mAllUCase & JoinStr & mAllLCase & JoinStr & mAutoSele & _
					JoinStr & mAccKey & JoinStr & mAccelerator & JoinStr & mPreStrRep & _
					JoinStr & mWebFlag & JoinStr & mCheckTrn & JoinStr & mAppStrRep & _
					JoinStr & KeepSet & JoinStr & ShowMsg & JoinStr & TranComm & JoinStr & UILangID
			tSelected = Split(Data,JoinStr)
		End If
		If (L$ = "" Or i = n) And Header <> "" And Header <> "Option" And Header <> "Update" Then
			Temp = ObjName & UrlTmp & AppId & Url & Method & Async & User & Pwd & Body & _
					rHead & rType & bStr & aStr & LngPair
			If Temp <> "" Then
				Data = Header & JoinStr & ObjName & SubJoinStr & AppId & SubJoinStr & Url & _
						SubJoinStr & UrlTmp & SubJoinStr & Method & SubJoinStr & Async & _
						SubJoinStr & User & SubJoinStr & Pwd & SubJoinStr & Body & _
						SubJoinStr & rHead & SubJoinStr & rType & SubJoinStr & bStr & _
						SubJoinStr & aStr & SubJoinStr & Enable & JoinStr & LngPair
				'¾ɰĬֵ
				If OldVersion <> "" And StrComp(NewVersion,OldVersion) = 1 Then
					If Join(UILangList,"") = "" Then
						Data = EngineDataUpdate(Header,Data)
					Else
						If InStr(Join(DefaultEngineList,JoinStr),Header) Then
							Data = EngineDataUpdate(Header,Data)
						End If
					End If
				End If
				'ݵ
				CreateArray(Header,Data,DataList)
				EngineGet = True
			End If
			'ݳʼ
			ObjName = ""
			UrlTmp = ""
			AppId = ""
			Url = ""
			Method = ""
			Async = ""
			User = ""
			Pwd = ""
			Body = ""
			rHead = ""
			rType = ""
			bStr = ""
			aStr = ""
			LngPair = ""
		End If
	Next i
	On Error GoTo 0
	If EngineGet = False Then GoTo GetFromRegistry
	Exit Function

	GetFromRegistry:
	'ȡ Option ֵ
	OldVersion = GetSetting("WebTranslate","Option","Version","")
	CheckSet = GetSetting("WebTranslate","Option","CheckSet","")
	mAllType = GetSetting("WebTranslate","Option","TranAllType",0)
	mMenu = GetSetting("WebTranslate","Option","TranMenu",0)
	mDialog = GetSetting("WebTranslate","Option","TranDialog",0)
	mString = GetSetting("WebTranslate","Option","TranString",0)
	mAccTable = GetSetting("WebTranslate","Option","TranAcceleratorTable",0)
	mVer = GetSetting("WebTranslate","Option","TranVersion",0)
	mOther = GetSetting("WebTranslate","Option","TranOther",0)
	mSelOnly = GetSetting("WebTranslate","Option","TranSeletedOnly",1)
	mForReview = GetSetting("WebTranslate","Option","SkipForReview",1)
	mValidated = GetSetting("WebTranslate","Option","SkipValidated",1)
	mNotTran = GetSetting("WebTranslate","Option","SkipNotTran",0)
	mNumAndSymbol = GetSetting("WebTranslate","Option","SkipAllNumAndSymbol",1)
	mAllUCase = GetSetting("WebTranslate","Option","SkipAllUCase",1)
	mAllLCase = GetSetting("WebTranslate","Option","SkipAllLCase",0)
	mAutoSele = GetSetting("WebTranslate","Option","AutoSelection",1)
	mAccKey = GetSetting("WebTranslate","Option","CheckAccessKey",1)
	mAccelerator = GetSetting("WebTranslate","Option","CheckAccelerator",1)
	mPreStrRep = GetSetting("WebTranslate","Option","CheckPreString",1)
	mWebFlag = GetSetting("WebTranslate","Option","CheckWebPageFlag",1)
	mCheckTrn = GetSetting("WebTranslate","Option","CheckTranslation",1)
	mAppStrRep = GetSetting("WebTranslate","Option","AutoRepString",1)
	KeepSet = GetSetting("WebTranslate","Option","KeepSetting",0)
	ShowMsg = GetSetting("WebTranslate","Option","ShowMassage",1)
	TranComm = GetSetting("WebTranslate","Option","AddTranComment",0)
	UILangID = GetSetting("WebTranslate","Option","UILanguageID",0)
	If SelSet = "" Then
		EngineSet = GetSetting("WebTranslate","Option","TranEngineSet","")
	End If
	Data = EngineSet & JoinStr & CheckSet & JoinStr & mAllType & JoinStr & mMenu & _
			JoinStr & mDialog & JoinStr & mString & JoinStr & mAccTable & JoinStr & _
			mVer & JoinStr & mOther & JoinStr & mSelOnly & JoinStr & mForReview & _
			JoinStr & mValidated & JoinStr & mNotTran & JoinStr & mNumAndSymbol & _
			JoinStr & mAllUCase & JoinStr & mAllLCase & JoinStr & mAutoSele & _
			JoinStr & mAccKey & JoinStr & mAccelerator & JoinStr & mPreStrRep & _
			JoinStr & mWebFlag & JoinStr & mCheckTrn & JoinStr & mAppStrRep & _
			JoinStr & KeepSet & JoinStr & ShowMsg & JoinStr & TranComm & JoinStr & UILangID
	tSelected = Split(Data,JoinStr)
	'ȡ Option ֵ
	HeaderIDs = GetSetting("WebTranslate","Option","Headers","")
	If HeaderIDs <> "" Then
		HeaderIDArr = Split(HeaderIDs,";",-1)
		For i = LBound(HeaderIDArr) To UBound(HeaderIDArr)
			HeaderID = HeaderIDArr(i)
			If HeaderID <> "" Then
				'תɰÿֵ
				Header = GetSetting("WebTranslate",HeaderID,"Name","")
				If Header = "" Then Header = HeaderID
				If Header <> "" Then
					ObjName = GetSetting("WebTranslate",HeaderID,"ObjectName","")
					AppId = GetSetting("WebTranslate",HeaderID,"AppId","")
					Url = GetSetting("WebTranslate",HeaderID,"EngineUrl","")
					UrlTmp = GetSetting("WebTranslate",HeaderID,"UrlTemplate","")
					Method = GetSetting("WebTranslate",HeaderID,"Method","")
					Async = GetSetting("WebTranslate",HeaderID,"Async","")
					User = GetSetting("WebTranslate",HeaderID,"User","")
					Pwd = GetSetting("WebTranslate",HeaderID,"Password","")
					Body = GetSetting("WebTranslate",HeaderID,"SendBody","")
					rHead = ReConvert(GetSetting("WebTranslate",HeaderID,"RequestHeader",""))
					rType = GetSetting("WebTranslate",HeaderID,"ResponseType","")
					bStr = GetSetting("WebTranslate",HeaderID,"TranBeforeStr","")
					aStr = GetSetting("WebTranslate",HeaderID,"TranAfterStr","")
					Enable = GetSetting("WebTranslate",HeaderID,"Enable",1)
					LngPair = GetSetting("WebTranslate",HeaderID,"LangCodePair","")
					Temp = ObjName & UrlTmp & AppId & Url & Method & Async & User & Pwd & Body & _
							rHead & rType & bStr & aStr & LngPair
					If Temp <> "" Then
						Data = Header & JoinStr & ObjName & SubJoinStr & AppId & SubJoinStr & Url & _
								SubJoinStr & UrlTmp & SubJoinStr & Method & SubJoinStr & Async & _
								SubJoinStr & User & SubJoinStr & Pwd & SubJoinStr & Body & _
								SubJoinStr & rHead & SubJoinStr & rType & SubJoinStr & bStr & _
								SubJoinStr & aStr & SubJoinStr & Enable & JoinStr & LngPair
						'¾ɰĬֵ
						If OldVersion <> "" And StrComp(NewVersion,OldVersion) = 1 Then
							If Join(UILangList,"") = "" Then
								Data = EngineDataUpdate(Header,Data)
							Else
								If InStr(Join(DefaultEngineList,JoinStr),Header) Then
									Data = EngineDataUpdate(Header,Data)
								End If
							End If
						End If
						'ݵ
						CreateArray(Header,Data,DataList)
						EngineGet = True
					End If
				End If
			End If
		Next i
	End If
End Function


'ȡִ
Function CheckGet(SelSet As String,DataList() As String,Path As String,mAutoSele As Long) As Boolean
	Dim i As Long,n As Long,Header As String,HeaderIDs As String,HeaderIDArr() As String,Temp As String
	CheckGet = False
	NewVersion = ToUpdateCheckVersion
	NewSet = SelSet

	If Path = CheckRegKey Then GoTo GetFromRegistry
	If Path = "" Then Path = CheckFilePath
	If Dir(Path) = "" Then GoTo GetFromRegistry
	On Error GoTo GetFromRegistry
	LineArray = Split(ReadFile(Path,"_autodetect_all"),vbCrLf)
	n = UBound(LineArray)
	For i = LBound(LineArray) To UBound(LineArray)
		L$ = LineArray(i)
		If Left(Trim(L$),1) = "[" And Right(Trim(L$),1) = "]" Then
			Header = Mid(Trim(L$),2,Len(Trim(L$))-2)
		End If
		If L$ <> "" And Header <> "" Then
			setPreStr = ""
			setAppStr = ""
			If InStr(L$,"=") Then setPreStr = Trim(Left(L$,InStr(L$,"=")-1))
			If InStr(L$,"=") Then setAppStr = LTrim(Mid(L$,InStr(L$,"=")+1))
			'ȡ Option ֵ
			If setPreStr = "Version" Then OldVersion = setAppStr
			If Header = "Option" And setPreStr <> "" Then
				If setPreStr = "AutoSelection" Then AutoSele = setAppStr
				If setPreStr = "AutoRepString" Then RepString = setAppStr
				If SelSet = "" Then
					If setPreStr = "AutoMacroSet" Then AutoMacroSet = setAppStr
				End If
			End If
			'ȡ Option ȫֵ
			If Header <> "Option" And Header <> "Update" And setPreStr <> "" Then
				If setPreStr = "ExcludeChar" Then ExCr = setAppStr
				If setPreStr = "LineSplitChar" Then LnSp = setAppStr
				If setPreStr = "CheckBracket" Then ChkBkt = setAppStr
				If setPreStr = "KeepCharPair" Then KpPair = setAppStr
				If setPreStr = "ShowAsiaKey" Then AsiaKey = setAppStr
				If setPreStr = "CheckEndChar" Then ChkEnd = setAppStr
				If setPreStr = "NoTrnEndChar" Then NoTrnEnd = setAppStr
				If setPreStr = "AutoTrnEndChar" Then TrnEnd = setAppStr
				If setPreStr = "CheckShortChar" Then Short = setAppStr
				If setPreStr = "CheckShortKey" Then Key = setAppStr
				If setPreStr = "KeepShortKey" Then KpKey = setAppStr
				If setPreStr = "PreRepString" Then PreStr = setAppStr
				If setPreStr = "AutoRepString" Then AppStr = setAppStr
				If setPreStr = "ApplyLangList" Then LngPair = setAppStr
				If AsiaKey = "" Then AsiaKey = "0"
			End If
		End If
		If (L$ = "" Or i = n) And Header <> "" And Header <> "Option" And Header <> "Update" Then
			If SelSet <> "" And mAutoSele = 1 Then
				If getCheckID(LngPair,SelSet) = True Then NewSet = Header
			End If
			If Header = NewSet Or (SelSet = "" And Header = AutoMacroSet) Then
				Temp = ExCr & LnSp & ChkBkt & KpPair & ChkEnd & NoTrnEnd & TrnEnd & _
						Short & Key & KpKey & PreStr & AppStr & LngPair
				If Temp <> "" Then
					Data = Header & JoinStr & ExCr & SubJoinStr & LnSp & SubJoinStr & ChkBkt & _
							SubJoinStr & KpPair & SubJoinStr & AsiaKey & SubJoinStr & ChkEnd & _
							SubJoinStr & NoTrnEnd & SubJoinStr & TrnEnd & SubJoinStr & Short & _
							SubJoinStr & Key & SubJoinStr & KpKey & SubJoinStr & PreStr & _
							SubJoinStr & AppStr & JoinStr & LngPair
					'¾ɰĬֵ
					If OldVersion <> "" And StrComp(NewVersion,OldVersion) = 1 Then
						If Join(UILangList,"") = "" Then
							Data = CheckDataUpdate(Header,Data)
						Else
							If InStr(Join(DefaultCheckList,JoinStr),Header) Then
								Data = CheckDataUpdate(Header,Data)
							End If
						End If
					End If
					DataList(0) = Data
					CheckGet = True
					Exit For
				End If
			End If
			'ݳʼ
			ExCr = ""
			LnSp = ""
			ChkBkt = ""
			KpPair = ""
			AsiaKey = ""
			ChkEnd = ""
			NoTrnEnd = ""
			TrnEnd = ""
			Short = ""
			Key = ""
			KpKey = ""
			PreStr = ""
			AppStr = ""
			LngPair = ""
		End If
	Next i
	On Error GoTo 0
	If CheckGet = False Then GoTo GetFromRegistry
	Exit Function

	GetFromRegistry:
	'ȡ Option ֵ
	OldVersion = GetSetting("AccessKey","Option","Version","")
	AutoSele = GetSetting("AccessKey","Option","AutoSelection",0)
	RepString = GetSetting("AccessKey","Option","AutoRepString",0)
	If SelSet = "" Then
		AutoMacroSet = GetSetting("AccessKey","Option","AutoMacroSet","")
	End If
	'ȡ Option ֵ
	HeaderIDs = GetSetting("AccessKey","Option","Headers","")
	If HeaderIDs <> "" Then
		HeaderIDArr = Split(HeaderIDs,";",-1)
		For i = LBound(HeaderIDArr) To UBound(HeaderIDArr)
			HeaderID = HeaderIDArr(i)
			If HeaderID <> "" Then
				'תɰÿֵ
				Header = GetSetting("AccessKey",HeaderID,"Name","")
				If Header = "" Then Header = HeaderID
				If SelSet <> "" And mAutoSele = 1 Then
					LngPair = GetSetting("AccessKey",HeaderID,"ApplyLangList","")
					If getCheckID(LngPair,SelSet) = True Then NewSet = Header
				End If
				If Header <> "" And (Header = NewSet Or (SelSet = "" And Header = AutoMacroSet)) Then
					ExCr = GetSetting("AccessKey",HeaderID,"ExcludeChar","")
					LnSp = GetSetting("AccessKey",HeaderID,"LineSplitChar","")
					ChkBkt = GetSetting("AccessKey",HeaderID,"CheckBracket","")
					KpPair = GetSetting("AccessKey",HeaderID,"KeepCharPair","")
					AsiaKey = GetSetting("AccessKey",HeaderID,"ShowAsiaKey",0)
					ChkEnd = GetSetting("AccessKey",HeaderID,"CheckEndChar","")
					NoTrnEnd = GetSetting("AccessKey",HeaderID,"NoTrnEndChar","")
					TrnEnd = GetSetting("AccessKey",HeaderID,"AutoTrnEndChar","")
					Short = GetSetting("AccessKey",HeaderID,"CheckShortChar","")
					Key = GetSetting("AccessKey",HeaderID,"CheckShortKey","")
					KpKey = GetSetting("AccessKey",HeaderID,"KeepShortKey","")
					PreStr = GetSetting("AccessKey",HeaderID,"PreRepString","")
					AppStr = GetSetting("AccessKey",HeaderID,"AutoRepString","")
					LngPair = GetSetting("AccessKey",HeaderID,"ApplyLangList","")
					Temp = ExCr & LnSp & ChkBkt & KpPair & ChkEnd & NoTrnEnd & TrnEnd & _
							Short & Key & KpKey & PreStr & AppStr & LngPair
					If Temp <> "" Then
						Data = Header & JoinStr & ExCr & SubJoinStr & LnSp & SubJoinStr & ChkBkt & _
								SubJoinStr & KpPair & SubJoinStr & AsiaKey & SubJoinStr & ChkEnd & _
								SubJoinStr & NoTrnEnd & SubJoinStr & TrnEnd & SubJoinStr & Short & _
								SubJoinStr & Key & SubJoinStr & KpKey & SubJoinStr & PreStr & _
								SubJoinStr & AppStr & JoinStr & LngPair
						'¾ɰĬֵ
						If Join(UILangList,"") = "" Then
							If OldVersion <> "" And StrComp(NewVersion,OldVersion) = 1 Then
								Data = CheckDataUpdate(Header,Data)
							End If
						Else
							If InStr(Join(DefaultCheckList,JoinStr),Header) Then
								If OldVersion <> "" And StrComp(NewVersion,OldVersion) = 1 Then
									Data = CheckDataUpdate(Header,Data)
								End If
							End If
						End If
						DataList(0) = Data
						CheckGet = True
						Exit For
					End If
				End If
			End If
		Next i
	End If
End Function


'ɰ汾ֵ
Function EngineDataUpdate(Header As String,Data As String) As String
	Dim UpdatedData As String,uV As String,dV As String
	TempArray = Split(Data,JoinStr)
	uSetsArray = Split(TempArray(1),SubJoinStr)
	dSetsArray = Split(EngineSettings(Header),SubJoinStr)
	For i = LBound(uSetsArray) To UBound(uSetsArray)
		uV = uSetsArray(i)
		dV = dSetsArray(i)
		If uV = "" Then uV = dV
		If uV <> "" And uV <> dV Then uV = dV
		uSetsArray(i) = uV
	Next i
	TempArray(1) = Join(uSetsArray,SubJoinStr)
	EngineDataUpdate = Join(TempArray,JoinStr)
End Function


'¼ɰ汾ֵ
Function CheckDataUpdate(Header As String,Data As String) As String
	Dim UpdatedData As String,uV As String,dV As String,spStr As String
	Dim i As Long,j As Long,m As Long,uDataList() As String,dDataList() As String
	CheckDataUpdate = Data
	dData = CheckSettings(Header)
	If dData = "" Or CheckDataUpdate = dData Then Exit Function
	TempArray = Split(Data,JoinStr)
	uSetsArray = Split(TempArray(1),SubJoinStr)
	dSetsArray = Split(dData,SubJoinStr)
	For i = LBound(uSetsArray) To UBound(uSetsArray)
		uV = uSetsArray(i)
		dV = dSetsArray(i)
		If uV = "" Then uV = dV
		If i <> 4 And uV <> "" And uV <> dV Then
			If i = 5 Or i = 7 Then
				spStr = " "
			Else
				spStr = ","
			End If
			If i = 0 Or i = 1 Then uV = dV
			If i = 7 And InStr(uV,"|") = 0 Then
				uDataList = Split(uV,spStr)
				For m = LBound(uDataList) To UBound(uDataList)
					uV = uDataList(m)
					uDataList(m) = Left(Trim(uV),1) & "|" & Right(Trim(uV),1)
				Next m
				uV = Join(uDataList,spStr)
			End If
			If i = 11 Or i = 12 Then uV = dV
			uV = Join(ClearArray(Split(uV & spStr & dV,spStr,-1)),spStr)
			uSetsArray(i) = uV
		End If
	Next i
	TempArray(1) = Join(uSetsArray,SubJoinStr)
	CheckDataUpdate = Join(TempArray,JoinStr)
End Function


'ӻĿ
Function CreateArray(Header As String,Data As String,DataList() As String) As Boolean
	Dim i As Long,n As Long
	If DataList(0) = "" Then
		DataList(0) = Data
	Else
		n = 0
		For i = LBound(DataList) To UBound(DataList)
			TempArray = Split(DataList(i),JoinStr)
			If LCase(TempArray(0)) = LCase(Header) Then
				DataList(i) = Data
				n = n + 1
				Exit For
			End If
		Next i
		If n = 0 Then
			i = UBound(DataList) + 1
			ReDim Preserve DataList(i)
			DataList(i) = Data
		End If
	End If
End Function


'ֵָǷ
Function getCheckID(Data As String,LngCode As String) As Boolean
	Dim i As Long,Stemp As Boolean
	getCheckID = False
	If LngCode = "" Or Data = "" Then Exit Function
	LangArray = Split(Data,SubJoinStr)
	For i = LBound(LangArray) To UBound(LangArray)
		LangPairList = Split(LangArray(i),LngJoinStr)
		If LCase(LangPairList(1)) = LCase(LngCode) Then
			getCheckID = True
			Exit For
		End If
	Next i
End Function


'
Function SortArray(xArray() As String,Comp As Long,CompType As String,Operator As String) As Variant
	Dim rMin As Long,rMax As Long,MaxLng As Long,Lng As Long,yArray() As String
	Dim fLng As Long,sLng As Long,fMargin As Long,sMargin As Long
	SortArray = xArray
	If rMax = 0 Or CompType = "" Or Operator = "" Then Exit Function
	yArray = xArray
	rMin = LBound(xArray)
	rMax = UBound(xArray)
    MaxLng = 1
    For x = rMin To rMax
        Lng = Len(Trim(yArray(x)))
        If Lng > MaxLng Then MaxLng = Lng
    Next
	For x = rMax To rMin Step -1
		For y = rMin To rMax - 1
			fLng = Len(Trim(yArray(y)))
			sLng = Len(Trim(yArray(y+1)))
			If CompType = "Size" Then
				fMargin = MaxLng - fLng
				sMargin = MaxLng - sLng
				fValue = String(fMargin,"0") & yArray(y)
				sValue = String(sMargin,"0") & yArray(y+1)
				MyComp = StrComp(fValue,sValue,Comp)
			End If
			If CompType = "Lenght" Then
				If fLng < sLng Then MyComp = -1
				If fLng = sLng Then MyComp = 0
				If fLng > sLng Then MyComp = 1
			End If
			If Operator = ">" Then
				If MyComp > 0 Then
					Mx = yArray(y + 1)
					yArray(y+1) = yArray(y)
					yArray(y) = Mx
				End If
			ElseIf Operator = "<" Then
				If MyComp < 0 Then
					Mx = yArray(y + 1)
					yArray(y+1) = yArray(y)
					yArray(y) = Mx
				End If
			ElseIf Operator = "=" Then
				If MyComp = 0 Then
					Mx = yArray(y + 1)
					yArray(y+1) = yArray(y)
					yArray(y) = Mx
				End If
			End If
		Next
	Next
	SortArray = yArray
End Function


'ظ
Function ClearArray(xArray() As String) As Variant
	Dim yArray() As String,Stemp As Boolean,i As Long,j As Long,y As Long
	ClearArray = xArray
	If UBound(xArray) = 0 Then Exit Function
	y = 0
	ReDim yArray(0)
	For i = LBound(xArray) To UBound(xArray)
		Stemp = False
		For j = i + 1 To UBound(xArray)
			If xArray(i) = xArray(j) Then
				Stemp = True
				Exit For
			End If
		Next j
		If Stemp = False Then
			ReDim Preserve yArray(y)
			yArray(y) = xArray(i)
			y = y + 1
		End If
	Next i
	ClearArray = yArray
End Function


'ֵָͨ
Function CheckKeyCode(FindKey As String,CheckKey As String) As Long
	Dim KeyCode As Boolean,FindStr As String,Key As String,pos As Long
	Key = Trim(FindKey)
	CheckKeyCode = 0
	If InStr(Key,"%") Then Key = Replace(Key,"%","x")
	If CheckKey <> "" And Key <> "" Then
		FindStrArr = Split(Convert(CheckKey),",",-1)
		For i = LBound(FindStrArr) To UBound(FindStrArr)
			FindStr = Trim(FindStrArr(i))
			If InStr(FindStr,"%") Then FindStr = Replace(FindStr,"%","x")
			If InStr(FindStr,"-") Then
				If Left(FindStr,1) <> "[" And Right(FindStr,1) <> "]" Then
					FindStr = "[" & FindStr & "]"
				End If
			End If
			If InStr(FindStr,"[") Then
				pos = InStr(FindStr,"[")
				If Left(FindStr,pos-1) <> "[" And Right(FindStr,pos+1) <> "]" Then
					FindStr = Replace(FindStr,"[","[[]")
				End If
			End If
			KeyCode = False
			CheckKeyCode = 0
			'PSL.Output Key & " : " &  FindStr  '
			KeyCode = UCase(Key) Like UCase(FindStr)
			If KeyCode = True Then CheckKeyCode = 1
			If KeyCode = True Then Exit For
		Next i
	ElseIf CheckKey = "" And Key <> "" Then
		CheckKeyCode = 1
	End If
End Function


'ȥִǰָ PreStr  AppStr
'fType = 0 ȥִǰո񣬵ȥִǰָ PreStr  AppStr
'fType = 1 ȥִǰո񣬲ȥִǰָ PreStr  AppStr
'fType = 2 ȥִǰո񣬽ȥִǰָ PreStr  AppStr 1 
'fType > 2 ȥִǰո񣬽ȥִǰָ PreStr  AppStr 1 
Function RemoveBackslash(Path As String,PreStr As String,AppStr As String,fType As Long) As String
	Dim i As Long,Stemp As Boolean
	RemoveBackslash = Path
	If Path = "" Then Exit Function
	If fType = 1 Or fType > 2 Then RemoveBackslash = Trim(RemoveBackslash)
	For i = 0 To 1
		Stemp = False
		If PreStr <> "" And Left(RemoveBackslash,Len(PreStr)) = PreStr Then
			RemoveBackslash = Mid(RemoveBackslash,Len(PreStr)+1)
			Stemp = True
		End If
		If AppStr <> "" And Right(RemoveBackslash,Len(AppStr)) = AppStr Then
			RemoveBackslash = Left(RemoveBackslash,Len(RemoveBackslash)-Len(AppStr))
			Stemp = True
		End If
		If fType = 1 Or fType > 2 Then RemoveBackslash = Trim(RemoveBackslash)
		If Stemp = True Then
			If fType < 2 Then i = 0 Else i = 1
		End If
		If Stemp = False Then Exit For
	Next i
End Function


' ļϢ
Sub ErrorMassage(MsgType As String)
	Dim MsgList() As String

	ItemList$ = "ErrorMassage"
	If getMsgList(UILangList,MsgList,ItemList$,0) = False Then
		On Error Resume Next
		Err.Raise(1,"NotSection",LangFile & JoinStr & ItemList$)
		Call sysErrorMassage(Err)
		On Error GoTo 0
		Exit Sub
	End If

	If MsgType = "NotReadFile" Then PSL.Output(MsgList(0) & ": " & MsgList(1))
	If MsgType = "NotWriteFile" Then PSL.Output(MsgList(0) & ": " & MsgList(2))
End Sub


' ļ
' ----------------------------------------------------
' ANSI      ޸ʽ
' EFBB BF   UTF-8
' FFFE      UTF-16LE/UCS-2, Little Endian with BOM
' FEFF      UTF-16BE/UCS-2, Big Endian with BOM
' XX00 XX00 UTF-16LE/UCS-2, Little Endian without BOM
' 00XX 00XX UTF-16BE/UCS-2, Big Endian without BOM
' FFFE 0000 UTF-32LE/UCS-4, Little Endian with BOM
' 0000 FEFF UTF-32BE/UCS-4, Big Endian with BOM
' XX00 0000 UTF-32LE/UCS-4, Little Endian without BOM
' 0000 00XX UTF-32BE/UCS-4, Big Endian without BOM
' е XX ʾʮַ

Function CheckCode(FilePath As String) As String
	Dim objStream As Object,i As Long,Code As String
	If FilePath = "" Then Exit Function
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo 0
	If Not objStream Is Nothing Then
		objStream.Type = 1
		objStream.Mode = 3
		objStream.Open
		objStream.Position = 0
		objStream.LoadFromFile FilePath
		Bin = objStream.read(4)
		objStream.Close
		Bin1 = AscB(MidB(Bin,1,1))
		Bin2 = AscB(MidB(Bin,2,1))
		Bin3 = AscB(MidB(Bin,3,1))
		Bin4 = AscB(MidB(Bin,4,1))
		If Bin1 = &HEF And Bin2 = &HBB Then
			CheckCode = "utf-8EFBB"
		ElseIf Bin1 = &HFF And Bin2 = &HFE Then
			CheckCode = "unicodeFFFE"
		ElseIf Bin1 = &HFE And Bin2 = &HFF Then
			CheckCode = "unicodeFEFF"
		ElseIf Bin1 <> &H00 And Bin2 = &H00 And Bin3 <> &H00 And Bin4 = &H00 Then
			CheckCode = "utf-16LE"
		ElseIf Bin1 = &H00 And Bin2 <> &H00 And Bin3 = &H00 And Bin4 <> &H00 Then
			CheckCode = "utf-16BE"
		ElseIf Bin1 = &HFF And Bin2 = &HFE And Bin3 = &H00 And Bin4 = &H00 Then
			CheckCode = "unicode-32FFFE"
		ElseIf Bin1 = &H00 And Bin2 = &H00 And Bin3 = &HFE And Bin4 = &HFF Then
			CheckCode = "unicode-32FEFF"
		ElseIf Bin1 = &H00 And Bin2 = &H00 And Bin3 = &H00 And Bin4 <> &H00 Then
			CheckCode = "utf-32LE"
		ElseIf Bin1 <> &H00 And Bin2 = &H00 And Bin3 = &H00 And Bin4 = &H00 Then
			CheckCode = "utf-32BE"
		Else
			Code = "_autodetect_all"
			objStream.Type = 2
			objStream.Mode = 3
			objStream.Charset = Code
			objStream.Open
			objStream.LoadFromFile FilePath
			PreTextStr = objStream.ReadText
			objStream.Close
			For i = 38 To 2 Step -1
				If i <> 9 And i <> 13 Then
					TempArray = Split(CodeList(i),JoinStr)
					Code = TempArray(1)
					objStream.Type = 2
					objStream.Mode = 3
					objStream.Charset = Code
					objStream.Open
					objStream.LoadFromFile FilePath
					AppTextStr = objStream.ReadText
					objStream.Close
					If PreTextStr = AppTextStr Then
						CheckCode = Code
						Exit For
					End If
				End If
			Next i
			If CheckCode = "" Then
				For i = 41 To 39 Step -1
					If i <> 40 Then
						TempArray = Split(CodeList(i),JoinStr)
						Code = TempArray(1)
						objStream.Type = 2
						objStream.Mode = 3
						objStream.Charset = Code
						objStream.Open
						objStream.LoadFromFile FilePath
						AppTextStr = objStream.ReadText
						objStream.Close
						If PreTextStr = AppTextStr Then
							CheckCode = Code
							Exit For
						End If
					End If
				Next i
			End If
			If CheckCode = "" Then CheckCode = "ANSI"
		End If
		Set objStream = Nothing
	Else
		CheckCode = "ANSI"
	End If
End Function


' ȡļ
Function ReadFile(FilePath As String,CharSet As String) As String
	Dim objStream As Object,Code As String
	If FilePath = "" Then Exit Function
	On Error Resume Next
	Set objStream = CreateObject("Adodb.Stream")
	On Error GoTo ErrorMsg
	Code = CharSet
	If Not objStream Is Nothing Then
		If Code = "" Then Code = CheckCode(FilePath)
		If Code = "utf-8EFBB" Then Code = "utf-8"
		If Code <> "ANSI" Then
			objStream.Type = 2
			objStream.Mode = 3
			objStream.Charset = Code
			objStream.Open
			objStream.LoadFromFile FilePath
			ReadFile = objStream.ReadText
			objStream.Close
		End If
	End If
	If objStream Is Nothing Or Code = "ANSI" Then
		FN = FreeFile
		Open FilePath For Input As #FN
		While Not EOF(FN)
			Line Input #FN,l$
			If ReadFile <> "" Then ReadFile = ReadFile & vbCrLf & l$
			If ReadFile = "" Then ReadFile = l$
		Wend
		Close #FN
	End If
	On Error GoTo 0
	If Not objStream Is Nothing Then Set objStream = Nothing
	Exit Function

	ErrorMsg:
	If Not objStream Is Nothing Then Set objStream = Nothing
	ErrorMassage("NotReadFile")
	ReadFile = ""
End Function


'ҳ
Public Function CodePageList(MinNum As Long,MaxNum As Long) As Variant
	Dim i As Long,j As Long,CodePage() As String,MsgList() As String

	ItemList$ = "CodePageList"
	If getMsgList(UILangList,MsgList,ItemList$,0) = False Then
		Err.Raise(1,"NotSection",LangFile & JoinStr & ItemList$)
	End If

	CodePageCode = "ANSI|_autodetect_all|gb2312|hz-gb-2312|gb18030|big5|euc-jp|iso-2022-jp|shift_jis|" & _
					"_autodetect|ks_c_5601-1987|euc-kr|iso-2022-kr|_autodetect_kr|windows-874|" & _
					"windows-1258|iso-8859-4|windows-1257|ASMO-708|DOS-720|iso-8859-6|windows-1256|" & _
					"DOS-862|iso-8859-8-i|iso-8859-8|windows-1255|iso-8859-9|iso-8859-7|windows-1253|" & _
					"iso-8859-1|cp866|iso-8859-5|koi8-r|koi8-ru|windows-1251|ibm852|iso-8859-2|" & _
					"windows-1250|iso-8859-3|utf-7|utf-8EFBB|utf-8|unicodeFFFE|unicodeFEFF|utf-16LE|" & _
					"utf-16BE|unicode-32FFFE|unicode-32FEFF|utf-32LE|utf-32BE"
	CodePageCodeList = Split(CodePageCode,"|")

	i = UBound(MsgList)
	If MaxNum > i Then MaxNum = i
	ReDim CodePage(MaxNum - MinNum)
	For i = MinNum To MaxNum
		j = i - MinNum
		CodePage(j) = MsgList(i) & JoinStr & CodePageCodeList(i)
	Next i
	CodePageList = CodePage
End Function


'ȡԶ
Function LangCodeList(DataName As String,MinNum As Long,MaxNum As Long) As Variant
	Dim i As Long,j As Long,Code As String,LangName As String,LangPairs() As String

	PslLangCode = "|af|sq|am|ar|hy|as|az|ba|eu|be|BN|bs|br|bg|ca|zh-CN|zh-TW|co|hr|cs|da|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|gl|ka|de|el|kl|gu|ha|he|hi|hu|is|id|iu|ga|xh|zu|it|" & _
				"ja|kn|KS|kk|km|rw|kok|ko|kz|ky|lo|lv|lt|lb|mk|ms|ML|mt|mi|mr|mn|ne|no|nb|" & _
				"nn|or|ps|pl|pt|pa|qu|ro|ru|se|sa|sr|st|tn|SD|si|sk|sl|es|sw|sv|sy|tg|ta|tt|" & _
				"te|th|bo|tr|tk|ug|uk|ur|uz|vi|cy|wo"

	BingLangCode = "||||ar||||||||||bg||zh-CHS|zh-CHT|||cs|da|nl|en|||||fi|fr||||de|el||||he||" & _
				"hu|||||||it|ja|||||||ko||||lv|lt||||||||||no|no|no|||pl|pt|||ro|ru||||||||sk|" & _
				"sl|es||sv||||||th||tr||||||||"

	GoogleLangCode = "auto|af|sq||ar||||||be||||bg|ca|zh-CN|zh-TW||hr|cs|da|nl|en|et||fa|tl|fi|" & _
				"fr||gl||de|el||||iw|hi|hu|is|id||ga|||it|ja|||||||ko||||lv|lt||mk|ms||mt|||||" & _
				"no|no|no|||pl|pt|||ro|ru|||sr|||||sk|sl|es|sw|sv||||||th||tr|||uk|||vi|cy|"

	YahooLangCode = "||||||||||||||||zh|zt|||||nl|en||||||fr||||de|el|||||||||||||it|ja|||||||" & _
				"ko|||||||||||||||||||||pt||||ru||||||||||es||||||||||||||||||"

	en2zhCheck = "||||||||||||||||zh-CN|zh-TW|||||||||||||||||||||||||||||||ja|||||||ko|||||||" & _
				"||||||||||||||||||||||||||||||||||||||||||||||"

	zh2enCheck = "|af|sq|am|ar|hy|as|az|ba|eu|be|BN|bs|br|bg|ca|||co|hr|cs|da|nl|" & _
				"en|et|fo|fa|fil-PH|fi|fr|fy|gl|ka|de|el|kl|gu|ha|he|hi|hu|is|id|iu|ga|xh|zu|it|" & _
				"|kn|KS|kk|km|rw|kok||kz|ky|lo|lv|lt|lb|mk|ms|ML|mt|mi|mr|mn|ne|no|nb|" & _
				"nn|or|ps|pl|pt|pa|qu|ro|ru|se|sa|sr|st|tn|SD|si|sk|sl|es|sw|sv|sy|tg|ta|tt|" & _
				"te|th|bo|tr|tk|ug|uk|ur|uz|vi|cy|wo"

	PslLangCodeList = Split(PslLangCode,LngJoinStr)
	BingLangCodeList = Split(BingLangCode,LngJoinStr)
	GoogleLangCodeList = Split(GoogleLangCode,LngJoinStr)
	YahooLangCodeList = Split(YahooLangCode,LngJoinStr)
	en2zhCheckList = Split(en2zhCheck,LngJoinStr)
	zh2enCheckList = Split(zh2enCheck,LngJoinStr)

	LangMaxNum = UBound(PslLangCodeList)
	If MaxNum > LangMaxNum Then MaxNum = LangMaxNum
	ReDim LangPairs(MaxNum - MinNum)
	For i = MinNum To MaxNum
		j = i - MinNum
		LangCode = PslLangCodeList(i)
		If LangCode = "zh-CN" Or LangCode = "zh-TW" Or LangCode = "fil-PH" Then
			LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCodeLangRgn),pslCodeText)
		Else
			LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCode639_1),pslCodeText)
			If LangName = "3FF3F" Then
				LangName = PSL.GetLangCode(PSL.GetLangID(LangCode,pslCodeLangRgn),pslCodeText)
			End If
		End If
		If DataName = DefaultEngineList(0) Then Code = BingLangCodeList(i)
		If DataName = DefaultEngineList(1) Then Code = GoogleLangCodeList(i)
		If DataName = DefaultEngineList(2) Then Code = YahooLangCodeList(i)
		If DataName = DefaultCheckList(0) Then Code = en2zhCheckList(i)
		If DataName = DefaultCheckList(1) Then Code = zh2enCheckList(i)
		LangPairs(j) = LangName & LngJoinStr & LangCode & LngJoinStr & Code
	Next i
	LangCodeList = LangPairs
End Function


'ԴбӻȡָĿĿб
Function getMsgList(SourceList() As String,TargetList() As String,Items As String,fType As Long) As Boolean
	Dim i As Long,j As Long,m As Long,n As Long,SourceMax As Long,ItemMax As Long
	Dim ItemList() As String,TempList() As String
	getMsgList = False
	ItemList = Split(Items,"|")
	ItemMax = UBound(ItemList)
	SourceMax = UBound(SourceList)
	ReDim TargetList(0),TempList(0)
	For i = 0 To SourceMax
		L$ = SourceList(i)
		If Left(Trim(L$),1) = "[" And Right(Trim(L$),1) = "]" Then
			Header$ = Mid(Trim(L$),2,Len(Trim(L$))-2)
		End If
		If L$ <> "" And InStr(L$,"=") Then
			For j = 0 To ItemMax
				If Header$ = ItemList(j) Then
					setPreStr$ = ""
					setAppStr$ = ""
					setPreStr$ = Trim(Left(L$,InStr(L$,"=")-1))
					setAppStr$ = Trim(Mid(L$,InStr(L$,"=")+1))
					If setPreStr$ <> "" Then
						ReDim Preserve TempList(n)
						TempList(n) = Convert(RemoveBackslash(setAppStr$,"""","""",2))
						n = n + 1
					End If
					Exit For
				End If
			Next j
		End If
		If n > 0 And (Trim(L$) = "" Or i = SourceMax) Then
			If fType = 0 Then
				TargetList = TempList
				getMsgList = True
				Exit For
			Else
				ReDim Preserve TargetList(m)
				TargetList(m) = Header$ & JoinStr & Join(TempList,SubJoinStr)
				m = m + 1
				n = 0
				Items = RemoveBackslash(Replace(Replace(Items,Header$,""),"||","|"),"|","|",0)
				If m = ItemMax + 1 Then
					getMsgList = True
					Exit For
				End If
			End If
		End If
	Next i
End Function
